<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // clear coupons and discount from order
    if (isset($_SESSION['checkout']['coupons'])){unset($_SESSION['checkout']['coupons']);}
    $_SESSION['checkout']['discount']=0;

    if (!isset($_SESSION['cart']['products'])){return;}

    // get active coupons
    $coupon_count=0;

    //get auto apply coupons
    $coupon_search['type']=2;
    if ($auto_coupons=get_items('coupons',null,1,null,null,$coupon_search)){
        $coupon_count=count($auto_coupons);
    }

    // merge any user added coupons
    if (isset($_SESSION['applied_coupons'])){
        $item_num=$coupon_count;
        foreach($_SESSION['applied_coupons'] as $coupon_id => $value){
            $auto_coupons[$item_num]['id']=$coupon_id;
            $item_num++;
        }
        $coupon_count=count($auto_coupons);
    }
    if ($coupon_count<1){return;}

    $current_time=time();

    for ($item_num=0; $item_num<$coupon_count; $item_num++){


        if ($coupon_details=get_item_details('coupon',$auto_coupons[$item_num]['id'])){

            // check validity
            $invalid=0;
            if ($coupon_details['min_spend']>0){
                $check_spend=$_SESSION['cart']['subtotal']-$_SESSION['checkout']['discount'];
                if ($check_spend<$coupon_details['min_spend']){$invalid=1;}
            }
            if ($coupon_details['start_date']>0 && $current_time<$coupon_details['start_date']){$invalid=1;}
            if ($coupon_details['end_date']>0 && $current_time>$coupon_details['end_date']){$invalid=1;}

            $valid_user_group=0;
            foreach ($coupon_details["user_group"] as $user_group_id){
                if ($user_group_id=="0"){$valid_user_group=1; break;}
                elseif($user_group_id=="1" && isset($_SESSION['reg_user'])){$valid_user_group=1; break;}
                elseif(isset($_SESSION['reg_user']['user_group']) && in_array($user_group_id,$_SESSION['reg_user']['user_group'])){$valid_user_group=1; break;}
            }

            $invalid_category=0;
            if (isset($coupon_details['category']) && !empty($coupon_details['category'])){
                $invalid_category=1;
                foreach($_SESSION['cart']['products'] as $product_option_id => $product){
                    if (isset($product['category'])){
                        foreach ($product['category'] as $category_id => $value2){
                            if (in_array($category_id,$coupon_details['category'])){
                               $invalid_category=0;
                               for ($i=0; $i<$product['order_qty']; $i++){
                                  $multibuy_product_prices[]=$product['price'];
                               }
                               break;
                            }
                        }
                    }
                }
            }

            if ($invalid>0 || $valid_user_group<1 || $invalid_category>0){continue;}

            // apply coupon to order
            $_SESSION['checkout']['coupons'][$coupon_details['id']]=$coupon_details;
            $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=0;


            // old calculate coupon discount value
            /*
            if (isset($multibuy_product_prices)){
                if ($coupon_details['multibuy_qty']<1){$coupon_details['multibuy_qty']=1;}
                $multibuy_batches=floor(count($multibuy_product_prices)/$coupon_details['multibuy_qty']);
                if ($multibuy_batches>0){
                    $multibuy_product_count=$multibuy_batches*$coupon_details['multibuy_qty'];
                    $multibuy_price_total=0;
                    for ($i=0; $i<$multibuy_product_count; $i++){
                        $multibuy_price_total=$multibuy_price_total+$multibuy_product_prices[$i];
                    }

                    if ($coupon_details['value_type']<1){
                      // multibuy - multiple products for a particular price
                      $new_price=$multibuy_batches*$coupon_details['value'];
                      $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=$multibuy_price_total-$new_price;
                    }
                    else
                    {
                      // multibuy - percent discount
                      $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=($multibuy_price_total*$coupon_details['value'])/100;
                    }


                }
                unset($multibuy_product_prices);
            }
            */

            // calculate coupon discount value
            if (isset($multibuy_product_prices)){
                if ($coupon_details['multibuy_qty']<2){
                    $multibuy_product_count=count($multibuy_product_prices);
                    $multibuy_price_total=0;
                    for ($i=0; $i<$multibuy_product_count; $i++){
                        $multibuy_price_total=$multibuy_price_total+$multibuy_product_prices[$i];
                    }

                    if ($coupon_details['value_type']<1 && $multibuy_price_total>=$coupon_details['value']){
                      // apply standard discount
                      $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=$coupon_details['value'];
                    }
                    elseif($coupon_details['value_type']>0){
                      // apply percent discount
                      $percent_discount_price=($multibuy_price_total*$coupon_details['value'])/100;
                      if ($multibuy_price_total>=$percent_discount_price){
                          $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=$percent_discount_price;
                      }
                    }
                }
                else{
                    $multibuy_batches=floor(count($multibuy_product_prices)/$coupon_details['multibuy_qty']);
                    $multibuy_product_count=$multibuy_batches*$coupon_details['multibuy_qty'];
                    $multibuy_price_total=0;
                    for ($i=0; $i<$multibuy_product_count; $i++){
                        $multibuy_price_total=$multibuy_price_total+$multibuy_product_prices[$i];
                    }

                    if ($coupon_details['value_type']<1){
                      // multibuy - multiple products for a particular price
                      $new_price=$multibuy_batches*$coupon_details['value'];
                      $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=$multibuy_price_total-$new_price;
                    }
                    else
                    {
                      // multibuy - percent discount
                      $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=($multibuy_price_total*$coupon_details['value'])/100;
                    }
                }

                unset($multibuy_product_prices);
            }
            elseif ($coupon_details['value_type']<1){$_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=$coupon_details['value'];}
            elseif ($coupon_details['value_type']==1){
                 $_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=(($_SESSION['cart']['subtotal']-$_SESSION['checkout']['discount'])*$coupon_details['value'])/100;
            }

            // update total order discount
            //if (isset($_SESSION['checkout']['coupons'][$coupon_details['id']]['discount'])){
                // ensure discount amount is never less than 0
                if ($_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']<0){$_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=0;}
                else{$_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']=round($_SESSION['checkout']['coupons'][$coupon_details['id']]['discount'],2);}
                $new_discount_total=$_SESSION['checkout']['discount']+$_SESSION['checkout']['coupons'][$coupon_details['id']]['discount'];

                // check if total discount is exceeds order total
                if ($new_discount_total>$_SESSION['cart']['subtotal']){
                    // cancel this coupon and any subsequent coupons
                    //if (isset($_SESSION['checkout']['coupons'][$coupon_details['id']]['discount'])){unset($_SESSION['checkout']['coupons'][$coupon_details['id']]['discount']);}
                    //if (isset($_SESSION['checkout']['coupons'][$coupon_details['id']]['discount'])){unset($_SESSION['checkout']['coupons'][$coupon_details['id']]);}
                    unset($_SESSION['checkout']['coupons'][$coupon_details['id']]);
                    break;
                }
                else{$_SESSION['checkout']['discount']=$new_discount_total;}

            //}


        }

    }

    // cancel order discount and all coupons if total discount is equal to or greater than order total
    /*
    if ($_SESSION['checkout']['discount']>=$_SESSION['cart']['subtotal']){
       $_SESSION['checkout']['discount']=0;
       unset($_SESSION['checkout']['coupons']);
    }
    */


?>
