<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

	// set page title
	if ($page_title==''){$page_title.=cms_site_name.' - Login';}

	$login_form="<a id=\"login_form\"></a><h2>".$txt['Login']."</h2>";

	// display user login form
	if (isset($_SESSION['reg_user'])){
        $login_form.="<p>".$txt['Welcome']." ".short_name($_SESSION['reg_user']['name'])." [<a href=\"".cms_url."?logout\">".$txt['Logout']."</a>]</p>";
    }
	else{

		if (!isset($rvi_email)){$rvi_email='';}
		if (!isset($rvi_password)){$rvi_password='';}


        // login links
        if (!isset($cms_settings['users']['close_registration']) || $cms_settings['users']['close_registration']<1){$login_links[]="<a href=\"".cms_url."?register\">".$txt['Register']."</a>";}
        $login_links[]="<a href=\"".cms_url."?forgot_password\">".$txt['Forgot_Password']."</a>";

        $login_form.="<p>".$txt['Login_instruction']." ".link_str($login_links," / ")."</p>";

        // display login warnings
        if (isset($_SESSION['form']['login']['warning'])){
                $login_form.=display_warnings($_SESSION['form']['login']['warning']);
        }

		$login_form.="
		<form class=\"cms_form\" method=\"post\" action=\"#login_form\">
    	<div class=\"form_row form_row_medium\"><div class=\"form_row\" style=\"flex: 0 1 21em\"><label for=\"email\">".$txt['Email'].":</label><input type=\"text\" id=\"email\" name=\"email\" value=\"".(isset($_SESSION['form']['login']['email']) ? $_SESSION['form']['login']['email'] : "")."\" ></div><div class=\"form_row\" style=\"flex: 0 1 21em\"><label for=\"password\">".$txt['Password'].":</label> <input type=\"password\" id=\"password\" name=\"password\" value=\"".(isset($rvi_password) ? $rvi_password : '')."\"></div></div>
        <div class=\"form_row\"><label><input type=\"checkbox\" name=\"remember_login\"".(isset($_SESSION['form']['login']['remember_me']) ? " checked" : "")." /> ".$txt['Remember_Me']."</label><input type=\"hidden\" name=\"ulogin[]\" /><button type=\"submit\" class=\"btn btn_login\">".$txt['btn_login']."</button></div>
		</form>";
	}



?>
