<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

	// set page title
	$page_title.=cms_site_name.' - '.$txt['my_account'];
	
	// load customer details from file (migth remove loading this daata again and go with session data instead) need for password change
    if (!isset($user_id) && isset($_SESSION['reg_user']['id'])){$user_id=$_SESSION['reg_user']['id'];}

    if (isset($user_id)){$user_details=get_item_details('customer',$user_id);}

    if (admin_level('users')>1){$disable="";}
    elseif (admin_level()>0 || $cms_settings['users']['account_details_access']<1){$disable=" disabled ";}

	if (!isset($user_details) || !is_array($user_details)){
        if (cms_interface=="front"){
            // auto logout if customer details are not accessbile
  		    logout_user();
            include("login.php");
            $page_content['main'].=$login_form;
        }
        else{$page_content['main'].="Error: User details could not be found";}
    }
	else{

        if (cms_interface=="back"){$help_page="modify-user.htm";}

        if (cms_interface=="back" && !isset($rvi_myaccount)){$rvi_myaccount='details';}

        if (!isset($rvi_myaccount)){$rvi_myaccount='';}

        if ($rvi_myaccount=='' && $cms_settings['listings_enabled']>0 && !isset($rvi_order) && !isset($rvi_modify_listing)){
            if (isset($cms_settings['users']['profile_pages']) && $cms_settings['users']['profile_pages']>0){$rvi_myaccount='profile';}
            else{$rvi_myaccount='listings';}
        }

        if (cms_interface=="back"){

            // display user joined and last online info
            $last_login_txt="";
            if (isset($user_details['last_login'])){
                // calculate number of days since update
                $modified_time_midnight=mktime(0, 0, 0, date('m',$user_details['last_login']), date('d',$user_details['last_login']), date('Y',$user_details['last_login']));
                $num_of_days=(time()-$modified_time_midnight)/86400;
                if ($num_of_days<1){$last_online='today';}
                elseif ($num_of_days<2){$last_online='yesterday';}
                else {$last_online=date('jS F Y',$user_details['last_login']);}

                $last_login_txt=" and last online ".$last_online." at ".date('H:i',$user_details['last_login'])." (".$user_details['last_ip_address'].")";

            }

            $page_content['main'].="<h1>User ".$user_details['id']."<span class=\"sub-head\">joined ".date("d/m/y",$user_details['registered_timestamp'])." at ".date('H:i',$user_details['registered_timestamp']).$last_login_txt."<span></h1>";

            $page_content['main'].="<div class=\"owner_bar\"><a href=\"".cms_root_url."admin/?user=".$user_details['id']."\" title=\"".$user_details['name']."\"><i class=\"fas fa-user\"></i>".$user_details['name']."</a>&nbsp; <a href=\"".cms_root_url."admin/?email_user=".$user_details['id']."\" title=\"".$user_details['email']."\"><i class=\"fas fa-mail\"></i>".(display_type!='mobile' ? $user_details['email'] : "")."</a>";
            if ($user_details['phone']!=''){$page_content['main'].="&nbsp; <a href=\"tel:".$user_details['phone']."\" title=\"".$user_details['phone']."\"><i class=\"fas fa-phone\"></i>".$user_details['phone']."</a>";}
            $page_content['main'].="</div>";


            $page_content['main'].="<form class=\"ctrl_bar\" method=\"post\">";
            if (admin_level('orders')>1){$page_content['main'].="<button type=\"submit\" formaction=\"?modify_order&new&user=".$user_details['id']."\"><i class=\"fas fa-doc-new\"></i>New Order</button>";}
            if (admin_level('subs')>1){$page_content['main'].="<button type=\"submit\" formaction=\"?modify_subscription&new&user=".$user_details['id']."\"><i class=\"fas fa-doc-new\"></i>New Subscription</button>";}
            $page_content['main'].="<button type=\"submit\" formaction=\"?users\" name=\"delete_customer[]\" value=\"".$user_details['id']."\" onclick=\"return confirm('Warning: Are you sure you want to delete this user?');\" style=\"background-color: #eaa1a1\"><i class=\"fas fa-times-circle\"></i>Delete User</button>";
            if (admin_level()>9 && display_type!='mobile'){
                $page_content['main'].="<button type=\"button\" onclick=\"javascript:open_win('".cms_root_url."admin/?viewdata=customer&amp;id=".$user_details['id']."','Raw Data')\"><i class=\"fas fa-database\"></i>Data</button>";
            }
            $page_content['main'].="</form>";

        }
        elseif (isset($_SESSION['reg_user']['id']) && $_SESSION['reg_user']['id']==$user_id){
            // display successful login warning
            if (isset($_SESSION['form']['login']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['login']['warning_green'],'green');}
            $page_content['main'].='<h1>'.$txt['my_account'].'</h1>';
        }


/*       if (isset($cms_settings['users']['profile_pages']) && $cms_settings['users']['profile_pages']>0){$page_content['main'].="<div class=\"txt_link_bar\"><a href=\"".cms_url."?myaccount=profile\">My Profile</a> | <a href=\"".cms_url."?myaccount=details\">Account Details</a> | <a href=\"".cms_url."?myaccount=orders\">".$txt['Orders']."</a> | <a href=\"".cms_url."?myaccount=subscriptions\">Subscriptions</a> |$listings_link <a href=\"".cms_url."?myaccount=preferences\">Preferences</a> | <a href=\"".cms_url."?logout\">Logout</a></div>";}
        else {$page_content['main'].="<div class=\"txt_link_bar\"><a href=\"".cms_url."?myaccount=details\">My Details</a> | <a href=\"".cms_url."?myaccount=orders\">Order History</a> | <a href=\"".cms_url."?myaccount=subscriptions\">Subscriptions</a> |$listings_link <a href=\"".cms_url."?myaccount=preferences\">Preferences</a> | <a href=\"".cms_url."?logout\">Logout</a></div>";}*/


        // display account nav menu
        $txt_links=array();
        if (cms_interface=="back"){
            if (isset($cms_settings['users']['profile_pages']) && $cms_settings['users']['profile_pages']>0){$txt_links[]="<a href=\"".cms_url."?profile=".$user_id."\" target=\"_blank\">View Profile</a> | ";}
            $txt_links[]="<a href=\"".cms_root_url."admin/?user=".$user_id."&amp;myaccount=details\">User Details</a>";
            if (admin_level('orders')>0){
                if (admin_level('orders')>1){$txt_links[]="<a href=\"".cms_root_url."admin/?user=".$user_id."&amp;myaccount=orders\">Orders</a> - <a href=\"".cms_root_url."admin/?modify_order&amp;new&amp;user=".$user_id."\">Add</a>";}
                else{$txt_links[]="<a href=\"".cms_root_url."admin/?user=".$user_id."&amp;myaccount=orders\">Orders</a>";}
            }
            if (admin_level('subs')>0){
                if (admin_level('subs')>1){$txt_links[]="<a href=\"".cms_root_url."admin/?subscriptions&amp;search[customer_id]=".$user_id."\">Subscriptions</a> - <a href=\"".cms_root_url."admin/?modify_subscription&amp;new&amp;user=".$user_id."\">Add</a>";}
                else{$txt_links[]="<a href=\"".cms_root_url."admin/?subscriptions&amp;search[customer_id]=".$user_id."\">Subscriptions</a>";}
            }
            if (admin_level('applications')>0){$txt_links[]="<a href=\"".cms_root_url."admin/?applications&amp;search[customer_id]=".$user_id."\">Applications</a>";}
            if (admin_level('listings')>0){$txt_links[]="<a href=\"".cms_root_url."admin/?listings&amp;search[customer_id]=".$user_id."\">Listings</a>";}
            if (admin_level('users')>1){
                $txt_links[]="<a href=\"".cms_root_url."admin/?user=".$user_id."&amp;myaccount=settings\">Settings</a>";
                $txt_links[]="<a href=\"".cms_root_url."admin/?user=".$user_id."&amp;myaccount=log\">Log</a>";
            }
        }
        else{
            if (isset($cms_settings['users']['profile_pages']) && $cms_settings['users']['profile_pages']>0){$txt_links[]="<a href=\"".cms_url."?myaccount=profile\">My Profile</a>";}
            if (isset($cms_settings['users']['account_details_access']) || $cms_settings['users']['account_details_access']>0){$txt_links[]="<a href=\"".cms_url."?myaccount=details\">My Details</a>";}
            if (user_level('orders')>0){$txt_links[]="<a href=\"".cms_url."?myaccount=orders\">".$txt['Orders']."</a>";}
            if (user_level('subs')>0){$txt_links[]="<a href=\"".cms_url."?myaccount=subscriptions\">".$txt['Subscriptions']."</a>";}
            if (user_level('listings')>0){$txt_links[]="<a href=\"".cms_url."?myaccount=listings\">".$txt['Listings']."</a>";}
            $txt_links[]="<a href=\"".cms_url."?myaccount=settings\">Settings</a>";
            $txt_links[]="<a href=\"".cms_url."?logout\">Logout</a>";
        }
        if (!empty($txt_links)){
            $page_content['main'].="<div class=\"txt_link_bar\">";
            $link_count=0;
            foreach($txt_links as $txt_link){
                if ($link_count>0){$page_content['main'].=" <span>|</span> ";}
                $page_content['main'].=$txt_link;
                $link_count++;
            }
            $page_content['main'].="</div>";
        }

        $account_summary="";

        // display customers orders
        $search_for_user['customer_id']=$user_id;
        $user_order_count=0;
        if ($users_orders=get_items('orders',null,null,'id',1,$search_for_user)){$user_order_count=count($users_orders);}

        if ($user_order_count>0){

            $account_balance=0;

            $order_table_html="<table cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\" style=\"width: 100%\"><thead><tr><th style=\"text-align:left\">Date</th><th style=\"text-align:left\">".$txt['order_id']."</th><th style=\"text-align: center\">Balance</th></tr></thead><tbody>\n";
            $alternate_rowcol='';
            for ($item_num=0; $item_num<$user_order_count; $item_num++){

    	        $order_id=$users_orders[$item_num]['id'];

    	        if ($order_details=get_item_details('order',$order_id)){

                        if ($order_details['status']>3){continue;}

                        if (isset($order_details['currency_code'])){
                            $currency_code=$order_details['currency_code'];
                            $currency_symbol=get_currency_symbol($order_details['currency_code']);
                        }
                        else{
                            $currency_code=currency_code;
                            $currency_symbol=currency_symbol;
                        }

                        $order_total=$order_details['shipping_total']+$order_details['order_subtotal']-$order_details['discount'];

                        // check payments on order and deduct from total
                        $paid_total=0;
                        if (isset($order_details['payment'])){
                        	foreach($order_details['payment'] as $payment_id => $payment){
                                // calculate balance due after payments
                                if (!isset($payment['cancelled'])){$paid_total=$paid_total+$payment['amount'];}
                        	}
                        }
                        $order_total_balance=$order_total-$paid_total;
                        // if status is set to paid ensure balance is zero no matter if payments have been added to order or not
                        if ($order_details['status']==1 || $order_details['status']==2){
                            $order_total_balance=0;
                        }

                        // only show orders with total greater than zero
                       if ($order_total>0){

                            if ($order_details['status']<1){
                                $account_balance=$account_balance+$order_total_balance;
                                $order_status="<div style=\"color: #ff0000\">".$currency_symbol.number_format($order_total_balance,2)."</div>";

                                // display overdue notice
                                if (isset($order_details['due_date']) && $order_details['due_date']>0){
                                    $days_to_due=($order_details['due_date']-time())/86400;
                                    if ($days_to_due<1){
                                        $order_status.="<div style=\"color: #ff0000\">Overdue</div>";
                                    }
                                }

                                $order_status.="<div><a href=\"".cms_url."?paynow=".$order_details['id']."\">".$txt['pay_now']."</a></div>";
                            }
                            elseif ($order_details['status']==1 || $order_details['status']==2){$order_status='<font color="green">Paid</font>';}
                            elseif ($order_details['status']==3){$order_status='Cancelled';}
                            elseif ($order_details['status']>3){$order_status="<a href=\"".cms_url."?paynow=".$order_details['id']."\">".$txt['pending']."</a>";}
    		                //$order_table_html.="<tr".$alternate_rowcol."><td>".date("d/m/y",substr($order_id,0,-3))."</td><td><a href=\"".cms_url."?myaccount&amp;order=".$order_id."\">".$order_id."</a></td><td align=\"right\" style=\"padding-left: 15px\">".$currency_symbol.number_format($order_total,2)."</td><td align=\"right\" style=\"padding-left: 15px\">".$currency_symbol.number_format($order_total_balance,2)."</td><td style=\"text-align: center\">$order_status</td></tr>";
                            $order_table_html.="<tr".$alternate_rowcol."><td style=\"padding: 5px\">".date("d/m/y",substr($order_id,0,-3))."</td><td><a href=\"".cms_url."?myaccount&amp;order=".$order_id."\">".$order_id."</a></td><td style=\"text-align: center\">".$order_status."</td></tr>\n";
                            if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}
                        }
    	        }

            }
            $order_table_html.="</tbody></table>";

            // todo we might want to add different account balances based on different order currencies here
            if (cms_interface=="back"){
                $account_summary.=" - Account balance is <b>".currency_symbol.number_format($account_balance,2)."</b>";
                if ($account_balance>0){
                    $account_summary.=" <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_url."?paynow&amp;amount=".number_format($account_balance,2)."\">".$txt['pay_now']."</a> <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_root_url."admin/?orders&amp;search[customer_id]=".$user_id."\">View Orders</a> <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_root_url."admin/?email_user=".$user_id."&amp;account_summary=balance\">Remind</a>";
                }
            }
            elseif (isset($cms_settings['orders']['show_balance']) && $cms_settings['orders']['show_balance']>0){
                $account_summary.=" - Your account balance is <b>".currency_symbol.number_format($account_balance,2)."</b>";
                if ($account_balance>0){
                    $account_summary.=" <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_url."?paynow&amp;amount=".number_format($account_balance,2)."\">".$txt['pay_now']."</a> <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_url."?myaccount=orders\">View Orders</a>";
                }
            }

        }


        // display users subscriptions
        $search_for_user['customer_id']=$user_id;
        $user_subscription_count=0;
        if ($users_subscriptions=get_items('subscriptions',null,null,null,null,$search_for_user)){
            $user_subscription_count=count($users_subscriptions);
            if ($rvi_myaccount==''){$rvi_myaccount='subscriptions';}
        }

        $subscriptions_table_html="";
        if ($user_subscription_count>0){

            $subscriptions_table_html.="<form method=\"post\" action=\"\">";
            $subscriptions_table_html.="<table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\">";
            $subscriptions_table_html.="<tr><th style=\"text-align: left\">Subscription</th><th style=\"text-align: center\">Price".($cms_settings['b2b']>0 ? " (".$txt['excl_tax'].")" : "")."</th><th width=\"80\" style=\"text-align: center\">Renew</th></tr>";
            /*
            if (defined('display_type') && display_type=='mobile'){
                $subscriptions_table_html.="<table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\"><tr><th align=\"left\">Subscription</th><th>Price".($cms_settings['b2b']>0 ? " (".$txt['excl_tax'].")" : "")."</th><th width=\"80\">Renew</th></tr>";
            }
            else{
                $subscriptions_table_html.="<table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\"><tr><th align=\"left\">Subscription</th><th>Price".($cms_settings['b2b']>0 ? " (".$txt['excl_tax'].")" : "")."</th><th>Expires</th><th>Status</th><th width=\"80\">Renew</th></tr>";
            }
            */
            $alternate_rowcol='';
            $expiring_soon_count=0;
            for ($item_num=0; $item_num<$user_subscription_count; $item_num++){

                $subscription_id=$users_subscriptions[$item_num]['id'];
                $subscription_details=get_item_details('subscription',$subscription_id);

                // only show subscriptions with start time greater than zero
                if ($subscription_details['start_time']>0){

                    $expire_time=$subscription_details['start_time']+((($subscription_details['days']*24)*60)*60);
                    $expire_date=date("d/m/y",$expire_time);

                    $expires_in_time=($subscription_details['start_time']+($subscription_details['days']*86400)-time());
                    if ($expires_in_time>0 && $expires_in_time<86400){$expiring_soon_count++;$expires_in_time='<span style="color: #ff0000">'.$expire_date.' (in '.intval(($expires_in_time/60)/60).' hrs)</span>';}
                    elseif($expires_in_time>0 && $expires_in_time<2592000){$expiring_soon_count++;$expires_in_time='<span style="color: #ff0000">'.$expire_date.' (in '.intval($expires_in_time/86400).' days)</span>';}
                    elseif($expires_in_time>0){$expires_in_time=$expire_date.' (in '.intval($expires_in_time/86400).' days)';}
                    else{$expiring_soon_count++;$expires_in_time='<span style="color: #ff0000">'.$expire_date.' (expired)</span>';}

                }
                else{$expires_in_time="NA";}

                if ($subscription_details['status']>0){$status='Active';}else{$status='<span style=\"color: #ff0000\">Inactive</span>';}

                //$renew_form='<input type="hidden" name="add_to_cart" value="'.$subscription_details['product']['id'].'" /> <input type="hidden" name="subscription_id" value="'.$subscription_details['id'].'" />';

                $subscription_name_text=$subscription_details['name'];
                /*
                if (isset($subscription_details['product']['option'])){
                    $subscription_name_text.="<div style=\"font-size: 12px;\">";
                    foreach ($subscription_details['product']['option'] as $option => $value){
                        $subscription_name_text.=$option.': '.$value.'<br />';
                        //$renew_form.=' <input type="hidden" name="product_option['.$option.']" value="'.$value.'" />';
                    }
                    $subscription_name_text.="</div>";
                }
                */
                if (isset($subscription_details['product']['customer_note'])){
                    $subscription_name_text.="<div style=\"font-size: 12px;\">".$subscription_details['product']['customer_note']."</div>";
                    //$renew_form.=' <input type="hidden" name="customer_note" value="'.$subscription_details['product']['customer_note'].'" />';
                }

                $sub_renewal_price="";
                if (isset($subscription_details['product']['order_price'])){
                    if ($cms_settings['b2b']>0){
                        $sub_renewal_price=$subscription_details['product']['order_price'] / (($subscription_details['product']['tax_rate'] / 100) + 1);
                    }
                    else{$sub_renewal_price=$subscription_details['product']['order_price'];}

                    if (isset($subscription_details['currency_code'])){
                        $currency_code=$subscription_details['currency_code'];
                        $currency_symbol=get_currency_symbol($subscription_details['currency_code']);
                    }
                    else{
                        $currency_code=currency_code;
                        $currency_symbol=currency_symbol;
                    }

                    $sub_renewal_price=$currency_symbol.number_format($sub_renewal_price,2);

                }

                if (defined('display_type') && display_type=='mobile'){
                    $subscriptions_table_html.='<tr'.$alternate_rowcol.'><td><div style="width: 200px; word-wrap: break-word">'.$subscription_name_text.'</div><div style=\"font-size: 0.813em\">Expires: '.$expires_in_time.'<br>Status: '.$status.'</div></td><td style="text-align: center">'.$sub_renewal_price.'</td><td style="text-align: center"><input type="checkbox" name="renew_sub_ids[]" value="'.$subscription_details['id'].'" style=\"transform: scale(1.5)\" /></td></tr>';
                }
                else{
                    $subscriptions_table_html.='<tr'.$alternate_rowcol.'><td><div>'.$subscription_name_text.'</div><div style=\"font-size: 0.813em\">Expires: '.$expires_in_time.'<br>Status: '.$status.'</div></td><td style="text-align: center">'.$sub_renewal_price.'</td><td style="text-align: center"><input type="checkbox" name="renew_sub_ids[]" value="'.$subscription_details['id'].'" style=\"transform: scale(1.2)\" /></td></tr>';
                    //$subscriptions_table_html.='<tr'.$alternate_rowcol.'><td valign="top">'.$subscription_name_text.'</td><td valign="top" align="center">'.$sub_renewal_price.'</td><td valign="top" align="center">'.$expires_in_time.'</td><td valign="top" align="center">'.$status.'</td><td valign="top" align="center"><input type="checkbox" name="renew_sub_ids[]" value="'.$subscription_details['id'].'" /></td></tr>';
                }

                if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}


            }

            $subscriptions_table_html.="<tr><td colspan=\"5\" style=\"text-align: right; padding: 5px\"><input type=\"submit\" name=\"renew_subs\" value=\"Renew Selected\" class=\"btn\" /></td></tr></table>";

            //if ($cms_settings['b2b']>0){$txt['my_account_subscriptions_text_bottom']="Prices shown exclude tax. ".$txt['my_account_subscriptions_text_bottom'];}

            $subscriptions_table_html.="<div style=\"margin-top: 15px\">".$txt['my_account_subscriptions_text_bottom']."</div>";

            if ($expiring_soon_count>0){
                if (cms_interface=="back"){
                    $account_summary.="<div style=\"color: #ff0000;border: dashed #ff0000 1px;padding: 5px 10px;margin: 5px auto;\"><a href=\"".cms_root_url."admin/?subscriptions&amp;search[customer_id]=".$user_id."\" style=\"color: #ff0000; text-decoration: none\"><span style=\"color: #ff0000;text-decoration: underline\">".$expiring_soon_count." subscriptions</span> expired or expiring soon</a></div>";
                }
                else{
                    $account_summary.="<div style=\"color: #ff0000;border: dashed #ff0000 1px;padding: 5px 10px;margin: 5px auto;\"><a href=\"".cms_url."?myaccount=subscriptions\" style=\"color: #ff0000;text-decoration: none\"><span style=\"color: #ff0000;text-decoration: underline\">".$expiring_soon_count." subscriptions</span> expired or expiring soon</a></div>";
                }
            }
        }
        else{$subscriptions_table_html.='No active subscriptions found.';}

        // display account summary text
        if (isset($account_summary)){
            $page_content['main'].="<hr /><div class=\"acc_summary\">";
            if (cms_interface=="back"){$page_content['main'].=$user_details['name'];}
            else{$page_content['main'].="Welcome ".short_name($user_details['name']);}
            $page_content['main'].=$account_summary."</div><hr />";
        }

		if ($rvi_myaccount=='details'){

			if (isset($rvi_save)){

				$user_details['name']=sanitize_text_input($rvi_name);
				$user_details['phone']=sanitize_text_input($rvi_phone);

				if (isset($rvi_dob_month)){$user_details['dob_month']=$rvi_dob_month;}
				if (isset($rvi_dob_day)){$user_details['dob_day']=$rvi_dob_day;}
				if (isset($rvi_dob_year)){$user_details['dob_year']=$rvi_dob_year;}

				if (isset($rvi_address)){$user_details['address']=sanitize_text_input($rvi_address);}
				if (isset($rvi_address_2)){$user_details['address_2']=sanitize_text_input($rvi_address_2);}
				$user_details['city']=sanitize_text_input($rvi_city);
				$user_details['county']=sanitize_text_input($rvi_county);
				if (isset($rvi_postcode)){$user_details['postcode']=sanitize_text_input($rvi_postcode);}
				$user_details['country']=sanitize_text_input($rvi_country);
                $user_details['company']=sanitize_text_input($rvi_company);
                if (isset($rvi_bill_company)){$user_details['bill_company']=1;}else{$user_details['bill_company']=0;}

                if (isset($rvi_bio)){
                    $user_details['bio']=sanitize_text_input($rvi_bio);
                    if (strlen($user_details['bio'])>260){$_SESSION['form']['myaccount_details']['warning'][]='About Me text is too long.';}
                }

                if (isset($rvi_website)){
                    $rvi_website=sanitize_text_input($rvi_website);
                    if (strlen($rvi_website)<6){$rvi_website='';}
                    elseif (strtolower(substr($rvi_website,0,4))!='http'){$rvi_website='http://'.$rvi_website;}
                    $user_details['website']=$rvi_website;
                }
                if (isset($rvi_facebook)){
                    $rvi_facebook=sanitize_text_input($rvi_facebook);
                    if (strpos($rvi_facebook,'facebook.com')===false){$rvi_facebook='';}
                    elseif (strtolower(substr($rvi_facebook,0,4))!='http'){$rvi_facebook='http://'.$rvi_facebook;}
                    $user_details['facebook']=$rvi_facebook;
                }
                if (isset($rvi_linkedin)){
                    $rvi_linkedin=sanitize_text_input($rvi_linkedin);
                    if (strpos($rvi_linkedin,'linkedin.com')===false){$rvi_linkedin='';}
                    elseif (strtolower(substr($rvi_linkedin,0,4))!='http'){$rvi_linkedin='http://'.$rvi_linkedin;}
                    $user_details['linkedin']=$rvi_linkedin;
                }
                if (isset($rvi_twitter)){
                    $rvi_twitter=sanitize_text_input($rvi_twitter);
                    if (strpos($rvi_twitter,'twitter.com')===false){$rvi_twitter='';}
                    elseif (strtolower(substr($rvi_twitter,0,4))!='http'){$rvi_twitter='http://'.$rvi_twitter;}
                    $user_details['twitter']=$rvi_twitter;
                }
                if (isset($rvi_youtube)){
                    $rvi_youtube=sanitize_text_input($rvi_youtube);
                    if (strpos($rvi_youtube,'youtube.com')===false){$rvi_youtube='';}
                    elseif (strtolower(substr($rvi_youtube,0,4))!='http'){$rvi_youtube='http://'.$rvi_youtube;}
                    $user_details['youtube']=$rvi_youtube;
                }
			
				// check values
				if (strlen($user_details['name'])<2){$_SESSION['form']['myaccount_details']['warning'][]='Please enter your name';}

                // check image
            	if (is_uploaded_file($_FILES['image_file']['tmp_name'])){
                    if ($_FILES['image_file']['size']>MAX_UPLOAD_IMAGE_SIZE || ($_FILES['image_file']['type']!="image/pjpeg" && $_FILES['image_file']['type']!="image/jpeg" && $_FILES['image_file']['type']!="image/png" && $_FILES['image_file']['type']!="image/gif")){$_SESSION['form']['myaccount_details']['warning'][]="Error uploading image file. Invalid file type.";}
                    else{
                        // get size of uploaded image
                		$image_size=getimagesize($_FILES['image_file']['tmp_name']);
                        if ($image_size[2]!=IMAGETYPE_JPEG && $image_size[2]!=IMAGETYPE_PNG && $image_size[2]!=IMAGETYPE_GIF){$_SESSION['form']['myaccount_details']['warning'][]="Error uploading image file. Invalid file type.";}
                        elseif ($image_size[0]>MAX_UPLOAD_IMAGE_DIM || $image_size[1]>MAX_UPLOAD_IMAGE_DIM){$_SESSION['form']['myaccount_details']['warning'][]="Error uploading image file. Image dimensions (".$image_size[0]."x".$image_size[1].") are too big.";}
                        else{
                            //$image_fn=safe_file_name($_FILES['image_file']['name']);
                            $image_fn=$_FILES['image_file']['name'];
                            createthumb($_FILES['image_file']['tmp_name'],sys_image_dir.'/temp.jpg',100,100,1);
                            if (!file_exists(sys_image_dir.'/temp.jpg')){$_SESSION['form']['myaccount_details']['warning'][]="Error uploading image file. Image file must be a jpeg.";}
                            else{
                                $user_details['profile_image']=$image_fn;
                            }
                        }
                    }
            	}

				if (!isset($_SESSION['form']['myaccount_details']['warning'])){

                    // saving image
            		if (is_uploaded_file($_FILES['image_file']['tmp_name']) && isset($user_details['profile_image'])){
                        $save_dir=sys_data_dir.'/customers/'.$user_details['id'].'/';
            			if ($image_size[0]>MAX_UPLOADED_IMAGE_SIZE_X || $image_size[1]>MAX_UPLOADED_IMAGE_SIZE_Y){
                            // resize orignal image if bigger than max uploaded image sizes
                            createthumb($_FILES['image_file']['tmp_name'],$save_dir.$image_fn,MAX_UPLOADED_IMAGE_SIZE_X,MAX_UPLOADED_IMAGE_SIZE_Y,1);
            			}
                        elseif ($_FILES['image_file']['size']>MAX_UPLOADED_IMAGE_SIZE){
                            // resize orignal image if filesize is over MAX_UPLOADED_IMAGE_SIZE
                            createthumb($_FILES['image_file']['tmp_name'],$save_dir.$image_fn,$image_size[0],$image_size[1],1);
                        }
                        else{
                            // store original image as uploaded without resizing
            				move_uploaded_file($_FILES['image_file']['tmp_name'],$save_dir.$image_fn) or die ("Error - Could not copy Image File");
            			}
            		}

                    // user groups
                    if (cms_interface=="back"){
                        // first we clear out the user_groups for the user then we will add in the selected ones
                        if (isset($user_details['user_group'])){
                            $old_user_groups=$user_details['user_group'];
                            unset($user_details['user_group']);
                            foreach ($old_user_groups as $user_group_id){
                                if ($usergroup_details=get_item_details('usergroup',$user_group_id)){
                                    // always keep admin type usergroups as not shown unless main admin
                                    if (admin_level()<10 && $usergroup_details['admin']>0){$user_details['user_group'][]=$user_group_id;}
                                }
                            }
                            unset($old_user_groups);
                        }
                        // add any selected usergroups for the user
            			if (isset($rvi_user_groups) && count($rvi_user_groups)>0){
            				foreach ($rvi_user_groups as $user_group_id){
            					$user_details['user_group'][]=$user_group_id;
            				}
            			}

                        $user_details['admin_note']=$rvi_admin_note;

                    }

					// update customers details file
					save_item_details($user_details);
                    update_item_list_file('customers',array($user_details['id']));

                    // log customer back in with new details
                    if (isset($_SESSION['reg_user']['id']) && $_SESSION['reg_user']['id']==$user_id){
                        // login_user($user_details,$_SESSION['reg_user']['login_cookie']);
                        login_user($user_details);
                    }

                    if (cms_interface=="back"){
                        $_SESSION['form']['myaccount_details']['warning_green'][]='User details have been updated.';
                    }
                    else{
					    $_SESSION['form']['myaccount_details']['warning_green'][]='Your account details have been updated.';
                    }
				}
			
			}

            $page_content['main'].="<h3>".(cms_interface=="back" ? "Account Details" : "My Details")."</h3>";

            if (cms_interface=="back"){
			    $page_content['main'].="<p>Update account details for this user below. Users can update their own details at any time by logging into their <a href=\"".cms_url."?myaccount=details\" target=\"_blank\">user account page</a> and can also reset their password using the <a href=\"".cms_url."?forgot_password\" target=\"_blank\">forgot password page</a>.</p>";
            }else{
                $page_content['main'].="<p>Update your account details below.</p>";
            }

            // display warnings
            if (isset($_SESSION['form']['myaccount_details']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['myaccount_details']['warning']);}
            elseif (isset($_SESSION['form']['myaccount_details']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['myaccount_details']['warning_green'],'green');}

			// show hide javascript
			$page_meta.='<script type="text/javascript" src="'.cms_root_url.'/plugins/jquery.qtip/jquery.qtip.min.js"></script>
            <link type="text/css" rel="stylesheet" href="'.cms_root_url.'/plugins/jquery.qtip/jquery.qtip.min.css" />
            <script type="text/javascript">
            $(document).ready(function(){

                $(\'.tooltip\').qtip();

            });

            function restrict(mytextarea) {

    var maxlength = 255; // specify the maximum length

    if (mytextarea.value.length > maxlength){

    mytextarea.value = mytextarea.value.substring(0,maxlength);
    mytextarea.scrollTop = mytextarea.scrollHeight;

    }

    } // --> </script>';




			$page_content['main'].="<form action=\"\" class=\"cms_form\" method=\"post\" enctype=\"multipart/form-data\" autocomplete=\"off\">
            <a name=\"contact_details\"></a>
			<div class=\"form_row form_row_medium\"><label>Name:</label><input type=\"text\" name=\"name\" value=\"".$user_details['name']."\" ".$disable."/></div>";
            if (cms_interface=="back"){
                if (admin_level()>9){
                    $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label><div><a href=\"".cms_root_url."admin/?email_user=".$user_details['id']."\">".$user_details['email']."</a>".($user_details['verified']>0 ? " (Verified)" : " (Unverified)" )." <a href=\"".cms_root_url."admin/?user=".$user_id."&amp;myaccount=email\">Change</a></div></div>";
                }
                else{
                    $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label><div><a href=\"".cms_root_url."admin/?email_user=".$user_details['id']."\">".$user_details['email']."</a>".($user_details['verified']>0 ? " (Verified)" : " (Unverified)" )."</div></div>";
                }
            }
            else{
               $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label>".$user_details['email']."</div>";
            }
			$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Phone:</label><input type=\"text\" name=\"phone\" value=\"".(isset($user_details['phone']) ? $user_details['phone'] : "")."\" ".$disable."/></div>
            <hr />";

            $page_content['main'].="<div class=\"form_row\"><label>Address:</label><input type=\"text\" name=\"address\" value=\"".(isset($user_details['address']) ? $user_details['address'] : '')."\" ".$disable."/></div>
            <div class=\"form_row\" style=\"margin: 0\"><label class=\"zero_height\"></label><input type=\"text\" name=\"address_2\" value=\"".(isset($user_details['address_2']) ? $user_details['address_2'] : '')."\" ".$disable."/></div>";

            $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Town/City:</label><input type=\"text\" name=\"city\" value=\"".(isset($user_details['city']) ? $user_details['city'] : '')."\" ".$disable."/></div>
			<div class=\"form_row form_row_medium\"><label>County:</label><input type=\"text\" name=\"county\" value=\"".(isset($user_details['county']) ? $user_details['county'] : '')."\" ".$disable."/></div>";
			$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Post Code:</label><input type=\"text\" name=\"postcode\" value=\"".(isset($user_details['postcode']) ? $user_details['postcode'] : '')."\" ".$disable."/></div>";
			$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Country:</label><select name=\"country\"".$disable.">";

			// load countries
			$fn=sys_data_dir.'/settings/country_list_billing.txt';
			$country_list[]='---';
			if (file_exists($fn)){
				$fc=file($fn);
				if (count($fc)>0){$country_list=array_merge($country_list,$fc);}elseif (count($fc)==1){$country_list=$fc;}
			}

			$option=$country_list;
			$option_qty=count($option);
			for ($option_num=0;$option_num<$option_qty;$option_num++){
				$option[$option_num]=trim($option[$option_num]);
				if (isset($user_details['country']) && $user_details['country']==$option[$option_num]){
					$page_content['main'].="<option selected=\"selected\">".$option[$option_num]."</option>";
				}
				else{
					$page_content['main'].="<option>".$option[$option_num]."</option>";
				}
			}
			$page_content['main'].="</select></div>";

            //if (isset($cms_settings['users']['profile_pages']) && $cms_settings['users']['profile_pages']>0){
                $page_content['main'].="<hr />
                <div class=\"form_row\"><label>Company:</label><input type=\"text\" name=\"company\" value=\"".(isset($user_details['company']) ? $user_details['company'] : '')."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Bill Company:</label><div><input type=\"checkbox\" name=\"bill_company\" ".((isset($user_details['bill_company']) && $user_details['bill_company']>0) ? 'checked="checked"' : '')." ".$disable."/> <span class=\"small_note\">bill orders to company</span></div></div>
                <hr />
                <div class=\"form_row\"><label>Profile Pic:</label><input type=\"file\" name=\"image_file\"".$disable."/></div>
                <hr />
                <div class=\"form_row\"><label>About Me:</label><textarea name=\"bio\" id=\"bio\" onkeyup=\"restrict(this.form.bio)\" style=\"width: 100%; height: 100px\"".$disable.">".(isset($user_details['bio']) ? $user_details['bio'] : '')."</textarea></div>";

                $page_content['main'].="<hr />
                <div class=\"form_row form_row_tiny\"><label>Date of Birth:</label><select name=\"dob_month\"".$disable." style=\"margin-left: 10px;\">";
    			$option=array("---","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
    			$option_qty=count($option);
    			for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if ($user_details['dob_month']==$option[$option_num]){
    					$page_content['main'].="<option selected=\"selected\">".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].="</select>
    			<select name=\"dob_day\"".$disable." style=\"margin-left: 10px;\">";
    			unset($option);
    			$option[0]="---";
    			for ($day=1; $day<=31; $day++){$option[]=$day;}
    			$option_qty=count($option);
    			for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if ($user_details['dob_day']==$option[$option_num]){
    					$page_content['main'].="<option selected=\"selected\">".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].="</select>
    			<select name=\"dob_year\"".$disable." style=\"margin-left: 10px;\">";
    			unset($option);
    			$option[0]="---";
    			for ($year=intval(date("Y",time())); $year>=1900; $year--){$option[]=$year;}
    			$option_qty=count($option);
    			for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if ($user_details['dob_year']==$option[$option_num]){
    					$page_content['main'].="<option selected=\"selected\">".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].="</select></div>

                <hr />
                <div class=\"form_row\"><label>Website:</label><input type=\"text\" size=\"25\" name=\"website\" value=\"".(isset($user_details['website']) ? $user_details['website'] : '')."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Facebook:</label><input type=\"text\" size=\"25\" name=\"facebook\" value=\"".(isset($user_details['facebook']) ? $user_details['facebook'] : '')."\" ".$disable."/></div>
                <div class=\"form_row\"><label>LinkedIn:</label><input type=\"text\" size=\"25\" name=\"linkedin\" value=\"".(isset($user_details['linkedin']) ? $user_details['linkedin'] : '')."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Twitter:</label><input type=\"text\" size=\"25\" name=\"twitter\" value=\"".(isset($user_details['twitter']) ? $user_details['twitter'] : '')."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Youtube:</label><input type=\"text\" size=\"25\" name=\"youtube\" value=\"".(isset($user_details['youtube']) ? $user_details['youtube'] : '')."\" ".$disable."/></div>";

            //}



            if (cms_interface=="back"){

                // jquery multiselect javascript
                $page_meta.="<link rel=\"stylesheet\" href=\"".cms_root_url."plugins/jquery-ui-multiselect-widget-2.0.1/jquery.multiselect.css\" type=\"text/css\" />
                <link rel=\"stylesheet\" href=\"".cms_root_url."plugins/jquery-ui-multiselect-widget-2.0.1/jquery.multiselect.filter.css\" type=\"text/css\" />
                <link rel=\"stylesheet\" type=\"text/css\" href=\"".cms_root_url."plugins/jquery/jquery-ui-1.12.1/jquery-ui.min.css\" />
                <script src=\"".cms_root_url."plugins/jquery/jquery-ui-1.12.1/jquery-ui.min.js\"></script>
                <script src=\"".cms_root_url."plugins/jquery-ui-multiselect-widget-2.0.1/src/jquery.multiselect.js\" ></script>
                <script src=\"".cms_root_url."plugins/jquery-ui-multiselect-widget-2.0.1/src/jquery.multiselect.filter.js\" ></script>";

                $page_meta.="<script>
                	$(document).ready(function(){
                		$(\"#user_groups_select\").multiselect({
                            noneSelectedText: \"Select User Groups\",
                            selectedText: \"# User Groups Selected\",
                            selectedList: 1,
                            minWidth: 50
                        }).multiselectfilter();
                  });
                  </script>";


                $page_content['main'].="<hr />";

        		// display user groups
        		if ($user_groups=get_items('usergroups')){
                    $user_groups_count=count($user_groups);
                    $page_content['main'].="<h3>User Groups</h3><p class=\"small_note\">Select user groups for this customer below.</p>
                    <div class=\"form_row\"><select name=\"user_groups[]\" id=\"user_groups_select\" multiple=\"multiple\"".$disable." style=\"width: 100%\">";
        			for ($user_group_num=0; $user_group_num<$user_groups_count; $user_group_num++){
                        if ($user_groups[$user_group_num]['id']<2){continue;}
                        if ($usergroup_details=get_item_details('usergroup',$user_groups[$user_group_num]['id'])){
                            if ($usergroup_details['admin']>0 && admin_level()>9){$usergroup_details['name']="admin: ".$usergroup_details['name'];}
            				$page_content['main'].="<option value=\"".$usergroup_details['id']."\" ".(isset($user_details['user_group']) && in_array($usergroup_details['id'],$user_details['user_group']) ? "selected=\"selected\"" : "").">".$usergroup_details['name']."</option>";
                        }
        			}
        			$page_content['main'].="</select></div>";
        		}else{$page_content['main'].="<h3>User Groups</h3><p class=\"small_note\">No user groups found".(admin_level('users')>1 ? " - <a href=\"".cms_root_url."admin/?add_usergroup\">Create a new user group</a>" : ".")."</p>";}

                // get subscribed user groups
                $search_for_user['customer_id']=$user_id;
                $user_subscription_count=0;
                if ($users_subscriptions=get_items('subscriptions',null,null,null,null,$search_for_user)){$user_subscription_count=count($users_subscriptions);}

                if ($user_subscription_count>0){

                    for ($item_num=0; $item_num<$user_subscription_count; $item_num++){
                        $subscription_id=$users_subscriptions[$item_num]['id'];
                        if ($subscription_details=get_item_details('subscription',$subscription_id)){
                            if ($subscription_details['status']>0 && isset($subscription_details['product']['subscription_user_group'])){
                                $subscribed_user_groups[$subscription_details['id']]=$subscription_details;
                            }
                        }
                    }
                    // display subscribed user groups
                    if (isset($subscribed_user_groups)){
                        $page_content['main'].="<p class=\"small_note\">This user currently has ".count($subscribed_user_groups)." active subscription(s) to the user groups below.</p>";

                        foreach ($subscribed_user_groups as $subscription_id => $subscription_details){
                            $expires_in_time=($subscription_details['start_time']+($subscription_details['days']*86400)-time());
                            if ($expires_in_time>0 && $expires_in_time<86400){$expires_in_time='<span style="color: #ff0000">expires in '.intval(($expires_in_time/60)/60).' hrs</span>';}
                            elseif($expires_in_time>0 && $expires_in_time<2592000){$expires_in_time='<span style="color: #ff0000">expires in '.intval($expires_in_time/86400).' days</span>';}
                            elseif($expires_in_time>0){$expires_in_time='expires in '.intval($expires_in_time/86400).' days';}
                            else{$expires_in_time='expired';}
                            $page_content['main'].="<div style=\"padding-bottom: 4px\">Subscription: <a href=\"".cms_root_url."admin/?modify_subscription=".$subscription_id."\">".$subscription_details['name']."</a> (".$expires_in_time.")<br />User Groups: ";
                            $counter=0;
                            foreach ($subscription_details['product']['subscription_user_group'] as $user_group_id){
                                if (!isset($user_groups[$user_group_id])){continue;}
                                if ($counter>0){$page_content['main'].=', ';}
                                $page_content['main'].=$user_groups[$user_group_id]['name'];
                                $counter++;
                            }
                            $page_content['main'].="</div>";
                        }
                    }
                }


                $page_content['main'].="<hr />";
                $page_content['main'].="<h3>Admin Notes</h3><p>These notes are only visible to admin users.</p>
                <div class=\"form_row\"><textarea name=\"admin_note\"".$disable.">".(isset($user_details['admin_note']) ? $user_details['admin_note'] : "")."</textarea></div>";

            }



            if($disable=="" || (isset($_SESSION['reg_user']['id']) && $_SESSION['reg_user']['id']==$user_id)){$page_content['main'].="<div class=\"form_row_footer\"><input class=\"btn\" type=\"submit\" name=\"save\" value=\"".(cms_interface=='back' ? "Save Account Details" : "Save Account Details")."\" /></div>";}
            $page_content['main'].="</form>";
		
		}
        elseif ($rvi_myaccount=='profile'){

            $rvi_profile=$user_id;
            include('user_profile.php');

        }
		elseif ($rvi_myaccount=='referrals'){
            /*
			$page_content['main'].="<h3>Referrals</h3>";
						
			$referrals=get_refferals($_SESSION['reg_user']['id']);

			// display this customers referred orders
			$referred_order_count=0;
			if (isset($referrals['order'])){
				foreach ($referrals['order'] as $order_id => $vaule){
					$order_details=get_item_details('order',$order_id);
					if (is_array($order_details) && substr($order_details['status'],0,4)=="paid"){$referred_order_count++;}
				}
			}
			
			// display this customers referred customers
			$referred_customer_count=0;
			if (isset($referrals['member'])){
				foreach ($referrals['member'] as $member_id => $vaule){
					$user_details=get_item_details('customer',$member_id);
					if (is_array($user_details)){$referred_customer_count++;}
				}
			}
			$page_content['main'].="<p>You have referred <b>".$referred_order_count." orders</b> and <b>".$referred_customer_count." members</b>.</p>
			<p>To refer people to ".cms_site_name." simply append your member id <b>ref=".$_SESSION['reg_user']['id']."</b> to your links. You may link directly to any page URL (eg. a particular product/category) that begins with <b>".cms_url."?</b><br /><br />Example Link: ".cms_url."?ref=".$_SESSION['reg_user']['id']."</p>";
            */
		}
		elseif ($rvi_myaccount=='settings'){

            if (cms_interface=="back"){
                $page_content['main'].="<h3>Settings</h3><p><span style=\"color: #ff0000 \">Important:</span> Never change a users email preferences without their consent. Sending unsolicited emails to users can lead to your emails being flagged as spam and potential blacklisting of your websites email address and server.</p>";
            }
            else{
			    $page_content['main'].="<h3>Settings</h3>";
            }

			if (isset($rvi_save_settings)){
			
				if (!isset($rvi_newsetter_subscription)){$user_details['newsletter_subscription']="no";}
				else {$user_details['newsletter_subscription']="yes";}
			
				// update customers details file
				save_item_details($user_details);
				
				$settings_updated=TRUE;
				
			}

			if (isset($settings_updated)){$page_content['main'].=display_warnings(array('Settings Saved'),'green');}

			$page_content['main'].="<form method=\"post\" action=\"\">
				<table class=\"basic_table\"><tbody>";

                if (cms_interface=="back"){
                    /*
                    $page_content['main'].="<tr><td>New Password:</td><td><input type=\"password\" name=\"new_password\" value=\"\"></td></tr>
                    <tr><td>Re-Type:</td><td><input type=\"password\" name=\"confirm_new_password\" value=\"\"></td></tr>";
                    */
                    if ($disable==""){
                        $page_content['main'].="<tr><td>Password:</td><td><a href=\"".cms_root_url."admin/?user=".$user_id."&amp;myaccount=password\">Change password</a></td></tr>";
                        $page_content['main'].="<tr><td colspan=\"2\"><hr /></td></tr>";
                    }
                }
                else{
                    $page_content['main'].="<tr><td>Password:</td><td><a href=\"".cms_url."?myaccount=password\">Change my password</a></td></tr>";
                    $page_content['main'].="<tr><td colspan=\"2\"><hr /></td></tr>";
                }


				$page_content['main'].="<tr><td valign=\"top\">Receive Newsletter: </td><td><input type=\"checkbox\" name=\"newsetter_subscription\" "; if(isset($user_details['newsletter_subscription']) && $user_details['newsletter_subscription']=="yes"){$page_content['main'].="checked=\"checked\" ";} $page_content['main'].="/><br /><span class=\"small_note\">Check this box to receive our newsletter emails.<br />Uncheck if you do not want to receive our newsletter.</span></td></tr>
				<tr><td align=\"right\" colspan=\"2\"><button type=\"submit\" name=\"save_settings\" class=\"btn\">Save Settings</button></td></tr>
				<tbody></table>
				</form>";
			
			
		}
		elseif ($rvi_myaccount=="password"){

			if (isset($rvi_change_password_submit)){
			
				// check old password match
                if (cms_interface=="front" && check_password($user_details['password'],$rvi_old_password,$user_id)!=true){$_SESSION['form']['myaccount_changepass']['warning'][]="Current password is not correct";}
				if (strlen($rvi_new_passsword)<4){$_SESSION['form']['myaccount_changepass']['warning'][]="New password is too short (min 4 characters)";}
				if ($rvi_new_passsword!=$rvi_confirm_passsword){$_SESSION['form']['myaccount_changepass']['warning'][]="Confirm password does match";}

				if (!isset($_SESSION['form']['myaccount_changepass']['warning'])){
					// update password in session
					$user_details['password']=encrypt_password($rvi_new_passsword,$user_id);
					// update customers details file
					save_item_details($user_details);

                    update_item_log('user',$user_details['id'],short_name($user_details['name'],2)." ".$user_details['id']." changed password");

                    // ew only really want to send email if admin specifies, user doesn't really need the email if they change it themselves
                    //if (cms_interface=="front" || isset($rvi_admin_send_email)){
                    if (isset($rvi_admin_send_email)){

                        require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

        			    $mail = new PHPMailer();

                        // send mail via smtp if set in config file
                        if (defined('smtp_host')){
                            $mail->IsSMTP(); // send via SMTP
                            $mail->SMTPAuth = true; // turn on SMTP authentication
                            $mail->SMTPSecure = 'ssl';
                            $mail->Username = smtp_username; // SMTP username
                            $mail->Password = smtp_password; // SMTP password
                            $mail->Host       = smtp_host; // SMTP server
                            $mail->Port       = smtp_port; // SMTP server
                        }

        				// send confirmation email to user
        				$mail->From = $cms_settings['config']['site_email'];
        				$mail->FromName = cms_site_name;
        				$mail->AddAddress($user_details['email']);

        				$mail->Subject = cms_site_name.' - Password Changed';
                        if ($user_details['verified']<1){$verify_text='Click on the link below to verify your account and login.';}else{$verify_text='Click on the link below to login.';}
                        $mail->Body    = "Hi ".$user_details['name'].",\n\nYour new login password is ".$rvi_new_passsword."\n\n".$verify_text."\n\n".user_login_link($user_details,"?myaccount=password")."\n\n\n".cms_site_name."\n".cms_site_url;
                        $mail->IsHTML(FALSE);

        				if(!$mail->Send()){
                            update_item_log('user',$user_details['id'],"Warning: reset password email could not be sent");
                        }
                    }

                    $_SESSION['form']['myaccount_changepass']['warning_green'][]="Password changed successfully";


				}

			}

			$page_content['main'].="<h3>Change Password</h3>";

            if (cms_interface=="back"){
                $page_content['main'].="<p>Change the login password for this user below.</p>";
            }
            else{
                $page_content['main'].="<p>Enter your current password and new password below.</p>";
            }

            // display warnings
            if (isset($_SESSION['form']['myaccount_changepass']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['myaccount_changepass']['warning']);}
            if (isset($_SESSION['form']['myaccount_changepass']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['myaccount_changepass']['warning_green'],'green');}

            $page_content['main'].="<form method=\"post\" action=\"\" class=\"cms_form\">
            ";
            if (cms_interface=="front"){
                $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Current:</label><input type=\"password\" name=\"old_password\"></div>
                <hr />";
            }
            $page_content['main'].="<div class=\"form_row form_row_medium\"><label>New Pass:</label><input type=\"password\" name=\"new_passsword\"></div>
            <div class=\"form_row form_row_medium\"><label>Confirm:</label><input type=\"password\" name=\"confirm_passsword\"></div>";

            if (cms_interface=="back"){
                $page_content['main'].="<div class=\"small_note\"><hr /><input type=\"checkbox\" name=\"admin_send_email\" ".(isset($_SESSION['form']['no_email']) ? 'checked="checked" ' : '')." /> Check to send new password email to user</div>";
            }
            $page_content['main'].="<div class=\"form_row\"><button type=\"submit\" name=\"change_password_submit\" class=\"btn\">Change Password</button></div>

            </form>";


		}
        elseif ($rvi_myaccount=="email" && cms_interface=="back"){

			if (isset($rvi_change_email_submit)){

                $rvi_new_email=trim($rvi_new_email);

				// check email
				require(cms_root_dir."scripts/emailval.php");
		        if (strlen($rvi_new_email)<4 || strlen($rvi_new_email)>200 || MailVal($rvi_new_email,2)){$_SESSION['form']['myaccount_change_email']['warning'][]="Email address not valid";}
		        elseif (email_registered($rvi_new_email)){$_SESSION['form']['myaccount_change_email']['warning'][]=$txt['Warning_email_registered'];}

				if (!isset($_SESSION['form']['myaccount_change_email']['warning'])){
                    update_item_log('user',$user_details['id'],"Email address changed, user ".$user_details['id']);
                    if (!isset($user_details['admin_note'])){$user_details['admin_note']="";}
					$user_details['admin_note']=$user_details['admin_note']."\n\n".date('d/m/y H:i:s',time())." "."Email address changed from ".$user_details['email'];
					$user_details['email']=$rvi_new_email;
                    $user_details['verified']=0;
					// update customers details file
					save_item_details($user_details);
                    update_item_list_file('customers',array($user_details['id']));

					$email_change_success=TRUE;
				}

			}

			$page_content['main'].="<h3>Change Email Address</h3>";

            $page_content['main'].="<p>Change the email address for this user below. <b>Important:</b> This user will need to use the new email address to login and the owner of the new email address will be granted full access to this user account including any subscriptions, listings or orders associated with the account.</p>";

			if (isset($email_change_success)){$page_content['main'].=display_warnings(array('Email changed successfully'),'green');}
			else{

                // display warnings
                if (isset($_SESSION['form']['myaccount_change_email']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['myaccount_change_email']['warning']);}

				$page_content['main'].="<form method=\"post\" action=\"\">
				<table>";

                $page_content['main'].="<tr><td>Old Email: </td><td>".$user_details['email']."</td></tr>
                <tr><td colspan=\"2\"><hr /></td></tr>";

                $page_content['main'].="<tr><td>New Email: </td><td><input type=\"text\" name=\"new_email\"></td></tr>";

				$page_content['main'].="<tr><td align=\"right\" colspan=\"2\"><input type=\"submit\" name=\"change_email_submit\" value=\"Change Email\"></td></tr></table>

				</form>";
			}

		}
        elseif (isset($rvi_modify_listing)){
            $page_content['main'].="<h3>Edit ".$txt['Listing']."</h3>";
            include(cms_root_dir.'includes/users/listings/listing_modify.php');
        }
        elseif (isset($rvi_order)){

            $page_content['main'].="<h3>Order ".$rvi_order."</h3>";

			// display order detail
			if ($order_details=get_item_details('order',$rvi_order)){

                $page_content['main'].="<p>For a print friendly version of this invoice <a href=\"".cms_url."?print_invoice=".$rvi_order."\" target=\"_blank\">click here</a>.";

                if ($order_details['status']<1 || $order_details['status']>3){$page_content['main'].=' To pay this invoice <a href="'.cms_url.'?paynow='.$order_details['id'].'">click here</a>.';}

                $page_content['main'].="</p>";

                // order total including shipping
                //$order_total=$order_details['shipping_total']+$order_details['order_subtotal'];

                // display order invoice
                if (defined('display_type') && display_type=='mobile'){include(cms_root_dir.'includes/shop/view_invoice_mobile.php');}
                else{include(cms_root_dir.'includes/shop/view_invoice.php');}
                $page_content['main'].=$invoice;

			}else{$page_content['main'].='Order details not found.';}


		}
        elseif ($rvi_myaccount=="listings" && user_level('listings')>0){

			// show hide javascript
			$page_meta.="<script language=\"javascript\">
			function checker(message){return confirm(message);}
			</script>";

            // delete selected listinga
        	if (isset($rvi_delete_listings) && isset($rvi_select_listing_ids)){
                foreach ($rvi_select_listing_ids as $listing_id){
                    $item_details=get_item_details('listing',$listing_id);
                    $item_details['status']=0;
                    save_item_details($item_details);
                }
                update_item_list_file('listings',$rvi_select_listing_ids);
            }

			update_customer_listings_file($user_id);

            // renewing listings
            if (isset($rvi_renew_listings) && isset($rvi_select_listing_ids)){

                if (isset($order_details)){unset($order_details);}

                $order_details['item_type']='order';
                $order_details['customer_id']=$user_id;
                //$order_details['name']=$_SESSION['reg_user']['name'];
                //$order_details['email']=$_SESSION['reg_user']['email'];
                $order_details=$order_details+$_SESSION['reg_user'];
                $order_details['created_time']=time(); // make sure any created_time from user details is overwritten
                $order_details['id']=time().rand(100,999);
                // order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled, 4=pending
      			$order_details['status']=4;

                foreach ($rvi_select_listing_ids as $listing_id){

                    if ($listing_details=get_item_details('listing',$listing_id)){

                        // save product details in order
                        $order_details['products'][$listing_id]=$listing_details['product'];
                        $order_details['products'][$listing_id]['name']=$order_details['products'][$listing_id]['name'].=" (Renew Listing Ref:".$listing_id.")";
                        $order_details['products'][$listing_id]['listing_id']=$listing_id;
                        $order_details['products'][$listing_id]['order_price']=$listing_details['product']['price'];
                        $order_details['products'][$listing_id]['order_qty']=1;

                        // update renewed listing details only if current status is active or expired
                        if ($listing_details['status']==1 || $listing_details['status']==5){

                            // move renewed listings to top only if they are currently expired
                            if ($listing_details['status']==5){
                                foreach ($listing_details['category'] as $category_id => $value){
                                    if ($items=get_items('listings',$category_id,null,'priority',null,null,null,array(($listing_details['category'][$category_id]['priority']+1)))){$item_count=count($items);}else{$item_count=0;}
                                    if ($item_count>0){
                                        $listing_details['category'][$category_id]['priority']=$items[0]['priority'];
                                        // save_item_details($listing_details);
                                        // $update_item_ids[]=$listing_details_1['id'];
                                        for ($item_num=0; $item_num<$item_count; $item_num++){
                                           $listing_details_2=get_item_details('listing',$items[$item_num]['id']);
                                           $listing_details_2['category'][$category_id]['priority']=$listing_details_2['category'][$category_id]['priority']-1;
                                           save_item_details($listing_details_2);
                                           $update_listing_ids[]=$listing_details_2['id'];
                                        }
                                    }
                                }
                            }

                            // set status to awaiting approval if product price is 0 - otherwise awaiting payment
                            if ($listing_details['status']!=1){
                                if ($listing_details['product']['price']>0){$listing_details['status']=2;}
                                else{$listing_details['status']=3;}
                            }
                            $listing_details['subscription_start_time']=time();

                            save_item_details($listing_details);
                            $update_listing_ids[]=$listing_details['id'];
                        }


                    }

                }

                if (isset($update_listing_ids)){update_item_list_file('listings',$update_listing_ids);}

                $order_details['order_subtotal']=get_order_subtotal($order_details['products']);
                $order_details['shipping_total']=0;
                $order_details['discount']=0;
                $order_details['total']=$order_details['order_subtotal']+$order_details['shipping_total']-$order_details['discount'];

                $order_details['expire']=30;

                // only save orders with amount greater than zero
                if ($order_details['order_subtotal']>0){
                    save_item_details($order_details);
                    update_item_list_file('orders',array($order_details['id']),'add');
                    update_item_log('user',$user_id,'Order '.$order_details['id'].' created by user '.$user_id.' for listing renewal');

                	// redirect after form submit so browser back and refresh work without browser resend form data warning
                    header('HTTP/1.1 303 See Other');
                    header("Location: ".cms_url."?paynow=".$order_details['id']);
                    exit();
                }else{
                    $_SESSION['form']['myaccount_listings']['warning_green'][]="Thank You - Renewed listings will become active again shortly after review.";
                    update_item_log('user',$user_id,'Listing renewal by user '.$user_id);
                }

            }


            if (cms_interface=="back"){
                $page_content['main'].="<h3>Listings</h3><p>Here you can modify or remove this users listings and also renew their expired listings.</p>";

            }
            else{
			    $page_content['main'].="<h3>".$txt['Listings']."</h3>";
                if (strlen($txt['my_listings_description'])>0){$page_content['main'].='<p>'.$txt['my_listings_description'].'</p>';}
            }

            // display warnings
            if (isset($_SESSION['form']['myaccount_listings']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['myaccount_listings']['warning']);}
            elseif (isset($_SESSION['form']['myaccount_listings']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['myaccount_listings']['warning_green'],'green');}

			// display customer listings
            $search_for_users_listings['customer_id']=$user_id;
            $user_listing_count=0;
            if ($users_listings=get_items('listings',null,null,null,null,$search_for_users_listings)){$user_listing_count=count($users_listings);}

            if ($user_listing_count>0){

                $active_listing_count=0;

                $listing_table="<form method=\"post\" action=\"\"><table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\"><tr><th width=\"110\" align=\"left\"></th><th align=\"left\">".$txt['Listing']."</th><th>Status</th><th width=\"60\">Edit</th><th width=\"60\">Select</th></tr>";
                $alternate_rowcol='';

                for ($item_num=0; $item_num<$user_listing_count; $item_num++){

                    $listing_id=$users_listings[$item_num]['id'];
                    $listing_details=get_item_details('listing',$listing_id);

                    if ($listing_details['status']==1){$active_listing_count++;}

                    if ($listing_details['status']<1 && admin_level()<9){continue;}

                    if ($listing_details['status']==1){$listing_status='<font color="green">Active</font>';}
                    elseif ($listing_details['status']==2){
                        //$listing_status='<font color="red"><a href="'.cms_url.'?paynow='.$listing_details['order_id'].'">'.$txt['pay_now'].'</a></font>';
                        $listing_status="Pending";
                    }
                    elseif ($listing_details['status']==3){$listing_status='<font color="red">Awaiting Review</font>';}
                    elseif ($listing_details['status']==4){$listing_status='<font color="red">Rejected</font>';}
                    elseif ($listing_details['status']==5){$listing_status='<font color="red">Expired</font>';}
                    else{$listing_status='<font color="red">Inactive</font>';}

                    $image_html="";
                    if (isset($listing_details['image'])){
                        foreach ($listing_details['image'] as $image_fn => $value){break;}
                        // check if correct size image exists and create one if it doesn't
                        $listing_path=sys_data_dir.'/listings/'.$listing_details['id'].'/';
                        $tn_size_x=110;
                        $tn_size_y=90;
                        $aspect_ratio=0;
                    $thumbnail_fn=$tn_size_x."x".$tn_size_y.'_'.$aspect_ratio.'_l'.$listing_details['id'].'_'.$image_fn;
                    if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
                    createthumb($listing_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,$aspect_ratio);
                    }
                        $image_html='<a href="'.item_url('listing',$listing_details['id'],$listing_details['slug']).'"><img src="'.cms_image_url.$thumbnail_fn.'" width="'.$tn_size_x.'" height="'.$tn_size_y.'" /></a>';
                    }

                    $listing_table.="<tr".$alternate_rowcol."><td>".$image_html."</td><td><a href=\"".item_url('listing',$listing_details['id'],$listing_details['slug'])."\">".$listing_details['name']."</a></td><td align=\"center\">".$listing_status."</td><td align=\"center\"><a href=\"".(cms_interface=="back" ? cms_root_url."admin/?modify_listing=".$listing_id : cms_url."?myaccount&amp;modify_listing=".$listing_id )."\">Edit</a></td><td align=\"center\"><input type=\"checkbox\" name=\"select_listing_ids[]\" value=\"".$listing_details['id']."\" /></td></tr>";
                    if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}

                }

                $listing_table.="<tr><td colspan=\"5\" align=\"right\"><button type=\"submit\" name=\"renew_listings\" class=\"btn btn_small\">Renew Selected</button> <button type=\"submit\" name=\"delete_listings\" class=\"btn btn_small btn_red\" onclick=\"return checker('Are you sure you want to remove your selected ".strtolower($txt['Listings'])."?');\">Remove Selected</button></td></tr></table></form>";

                $page_content['main'].="<p>".$active_listing_count." active ".strtolower($txt['Listings'])."</p>".$listing_table;
            }
            /*
			$customer_listings_fn=sys_data_dir.'/customers/'.$user_id.'/listings.php';
			if (file_exists($customer_listings_fn)){
				$fc=array_reverse(file($customer_listings_fn));
				if (count($fc)>0){
					$page_content['main'].="<form method=\"post\" action=\"\"><table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\"><tr><th width=\"110\" align=\"left\"></th><th align=\"left\">Listing Name</th><th>Status</th><th width=\"60\">".$txt['listing_renew']."</th><th width=\"60\">Modify</th><th width=\"60\">Remove</th></tr>";
                    $alternate_rowcol='';
                    foreach ($fc as $line){
                        $pieces=explode('|',$line);
						$listing_id=$pieces[0];
						$listing_details=get_item_details('listing',$listing_id);

                        if ($listing_details['status']<1 && !isset($_SESSION['Logged_In_Admin'])){continue;}

                        if ($listing_details['status']==1){$listing_status='<font color="green">Active</font>';}
                        elseif ($listing_details['status']==2){$listing_status='<font color="red"><a href="'.cms_url.'?paynow='.$listing_details['order_id'].'">Pay Now</a></font>';}
                        elseif ($listing_details['status']==3){$listing_status='<font color="red">Awaiting Review</font>';}
                        elseif ($listing_details['status']==4){$listing_status='<font color="red">Rejected</font>';}
                        elseif ($listing_details['status']==5){$listing_status='<font color="red">Expired</font>';}
                        else{$listing_status='<font color="red">Inactive</font>';}

                        $image_html='';
                        if (isset($listing_details['image'])){
                            foreach ($listing_details['image'] as $image_fn => $value){break;}
                            // check if correct size image exists and create one if it doesn't
                            $listing_path=sys_data_dir.'/listings/'.$listing_details['id'].'/';
                            $tn_size_x=110;
                            $tn_size_y=90;
                            $aspect_ratio=0;
              				$thumbnail_fn=$tn_size_x."x".$tn_size_y.'_'.$aspect_ratio.'_l'.$listing_details['id'].'_'.$image_fn;
              				if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
              					createthumb($listing_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,$aspect_ratio);
              				}
                            $image_html='<a href="'.item_url('listing',$listing_details['id'],$listing_details['slug']).'"><img src="'.cms_image_url.$thumbnail_fn.'" width="'.$tn_size_x.'" height="'.$tn_size_y.'" /></a>';
                        }

						$page_content['main'].="<tr".$alternate_rowcol."><td>".$image_html."</td><td><a href=\"".item_url('listing',$listing_details['id'],$listing_details['slug'])."\">".$listing_details['name']."</a></td><td align=\"center\">".$listing_status."</td><td align=\"center\"><a href=\"".cms_url."?renew_listing=".$listing_details['id']."\">".$txt['listing_renew']."</a></td><td align=\"center\"><a href=\"".(cms_interface=="back" ? cms_root_url."admin/?modify_listing=".$listing_id : cms_url."?myaccount&amp;modify_listing=".$listing_id )."\">Modify</a></td><td align=\"center\"><input type=\"checkbox\" name=\"delete_listing[]\" value=\"$listing_id\"></td></tr>";
                        if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}
					}
					$page_content['main'].="<tr><td colspan=\"6\" align=\"right\"><input type=\"submit\" name=\"delete_listings\" value=\"Remove Selected\" onclick=\"return checker('Are you sure you want to remove your selected listings?');\" /></td></tr></table></form>";
				}
			}
            */

		}
        elseif ($rvi_myaccount=="subscriptions" || $rvi_myaccount=="subs"){

            // renewing subscriptions
            if (isset($rvi_renew_subs) && isset($rvi_renew_sub_ids)){

                if (isset($order_details)){unset($order_details);}

                $order_details['item_type']='order';
                $order_details['customer_id']=$user_id;
                //$order_details['name']=$_SESSION['reg_user']['name'];
                //$order_details['email']=$_SESSION['reg_user']['email'];
                $order_details=$order_details+$_SESSION['reg_user'];
                $order_details['created_time']=time(); // make sure any created_time from user details is overwritten

                $order_details['id']=time().rand(100,999);
                // order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled, 4=pending
      			$order_details['status']=4;

                foreach ($rvi_renew_sub_ids as $sub_id){

                    if ($subscription_details=get_item_details('subscription',$sub_id)){

                        // save product details in order
                        $order_details['products'][$sub_id]=$subscription_details['product'];
                        $order_details['products'][$sub_id]['name']=$subscription_details['name']." (Renewal)";
                        $order_details['products'][$sub_id]['subscription_id']=$sub_id;
                        $order_details['products'][$sub_id]['order_price']=$subscription_details['product']['order_price'];
                        $order_details['products'][$sub_id]['order_qty']=1;

                    }

                }

                $order_details['order_subtotal']=get_order_subtotal($order_details['products']);
                $order_details['shipping_total']=0;
                $order_details['discount']=0;
                $order_details['total']=$order_details['order_subtotal']+$order_details['shipping_total']-$order_details['discount'];

                $order_details['expire']=30;

                save_item_details($order_details);
                update_item_list_file('orders',array($order_details['id']),'add');

                update_item_log('user',$user_id,'Order '.$order_details['id'].' created by user '.$user_id.' for subscription renewal');

            	// redirect after form submit so browser back and refresh work without browser resend form data warning
                header('HTTP/1.1 303 See Other');
                header("Location: ".cms_url."?paynow=".$order_details['id']);
                exit();

            }


			$page_content['main'].="<h3>".$txt['Subscriptions']."</h3>";

            if (isset($txt['my_subscriptions_description']) && $txt['my_subscriptions_description']!=""){$page_content['main'].="<p>".$txt['my_subscriptions_description']."</p>";}

            // display users subscriptions
            $page_content['main'].=$subscriptions_table_html;

        }
        elseif($rvi_myaccount=='log' && admin_level()>0){
            include(cms_root_dir.'admin/includes/log.php');
        }
		else{

            if (cms_interface=="back"){
                //$page_content['main'].="<h3>Orders</h3>";
                $rvi_search['customer_id']=$user_details['id'];
                include(cms_root_dir.'admin/includes/shop/orders.php');
            }
            else{
			    $page_content['main'].="<h3>".$txt['Orders']."</h3>";


            if ($user_order_count>0){

                if (isset($txt['my_orders_description']) && $txt['my_orders_description']!=""){$page_content['main'].="<p>".$txt['my_orders_description']."</p>";}

                $page_content['main'].=$order_table_html;
            }
            else{
                if (cms_interface=="back"){
                    $page_content['main'].="No orders found for this user.";
                }
                else{
                    $page_content['main'].="Invoices for any orders or renewals you make will be listed here.";
                }
            }

            }


		}

	}

?>
