<?php

// this file is optional and allows you to override the default rules of the theme importer
// this file should reside in the config folder of the particular theme it applies to

// to exclude certain directories or files from being imported; list them one per line with a preceeding forward slash /
// paths must be relative to the theme directory eg. /mydir or /mydir/subdir/subdir or /myfile.txt or /mydir/subdir/subdir/myfile.txt
// the /config and /includes directories are always excluded even if not added here
$exclude_files_and_directories=array(
"/config",
"/includes"
);

// imported files can have their filename fingerprinted with a timestamp for cache busting purposes
// only files with the extensions specified will be fingerprinted eg. "css","js","png","jpg","jpeg","gif","pdf","ico","woff","eot","cur"
// set to null or empty array if you do not want any files fingerprinted
$fingerprint_file_types=array();

// fingerprinted filenames can sometimes cause problems when a filename is referenced in javascript
// to exclude certain files from being fingerprinted; list them one per line with a preceeding forward slash /
// paths must be relative to the theme directory eg. /mydir or /mydir/subdir/subdir or /myfile.txt or /mydir/subdir/subdir/myfile.txt
$exclude_fingerprint=array(
"/default_htm_files/zoomin.cur",
"/default_htm_files/zoomout.cur",
"/default_htm_files/customs.png"
);


?>