<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

	// set page title
	$page_title.=$txt['Checkout'];

	$_SESSION['order_stage']='checkout';

	// redirect tocart if no items ordered
	if (!isset($_SESSION['cart']['products']) || count($_SESSION['cart']['products'])<1){
        // redirect to cart
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?cart");
        exit();
    }

    // merge registered customer array to checkout array if logged in
    /*
    if (!isset($_SESSION['checkout']['id']) && isset($_SESSION['reg_user'])){
    	// if registered apply registered details to checkout
        $_SESSION['checkout']=array_merge($_SESSION['checkout'],$_SESSION['reg_user']);
    }

    if (isset($_SESSION['checkout']['created_time'])){unset($_SESSION['checkout']['created_time']);}
    */

    if (isset($_SESSION['reg_user']['id'])){$_SESSION['checkout']['customer_id']=$_SESSION['reg_user']['id'];}
    // name, email, phone
    if (!isset($_SESSION['checkout']['name'])){
        if (isset($_SESSION['reg_user']['name'])){$_SESSION['checkout']['name']=$_SESSION['reg_user']['name'];}else{$_SESSION['checkout']['name']='';}
    }
    if (!isset($_SESSION['checkout']['email'])){
        if (isset($_SESSION['reg_user'])){$_SESSION['checkout']['email']=$_SESSION['reg_user']['email'];}else{$_SESSION['checkout']['email']='';}
    }
    if (!isset($_SESSION['checkout']['phone'])){
        if (isset($_SESSION['reg_user']['phone'])){$_SESSION['checkout']['phone']=$_SESSION['reg_user']['phone'];}else{$_SESSION['checkout']['phone']='';}
    }
    // date of birth (might remove this in future)
    if (!isset($_SESSION['checkout']['dob_month'])){
        if (isset($_SESSION['reg_user']['dob_month'])){$_SESSION['checkout']['dob_month']=$_SESSION['reg_user']['dob_month'];}else{$_SESSION['checkout']['dob_month']='---';}
    }
    if (!isset($_SESSION['checkout']['dob_day'])){
        if (isset($_SESSION['reg_user']['dob_day'])){$_SESSION['checkout']['dob_day']=$_SESSION['reg_user']['dob_day'];}else{$_SESSION['checkout']['dob_day']='---';}
    }
    if (!isset($_SESSION['checkout']['dob_year'])){
        if (isset($_SESSION['reg_user']['dob_year'])){$_SESSION['checkout']['dob_year']=$_SESSION['reg_user']['dob_year'];}else{$_SESSION['checkout']['dob_year']='---';}
    }
    // main billing address
    if (!isset($_SESSION['checkout']['address'])){
        if (isset($_SESSION['reg_user']['address'])){$_SESSION['checkout']['address']=$_SESSION['reg_user']['address'];}else{$_SESSION['checkout']['address']='';}
    }
    if (!isset($_SESSION['checkout']['address_2'])){
        if (isset($_SESSION['reg_user']['address_2'])){$_SESSION['checkout']['address_2']=$_SESSION['reg_user']['address_2'];}else{$_SESSION['checkout']['address_2']='';}
    }
    if (!isset($_SESSION['checkout']['city'])){
        if (isset($_SESSION['reg_user']['city'])){$_SESSION['checkout']['city']=$_SESSION['reg_user']['city'];}else{$_SESSION['checkout']['city']='';}
    }
    if (!isset($_SESSION['checkout']['county'])){
        if (isset($_SESSION['reg_user']['county'])){$_SESSION['checkout']['county']=$_SESSION['reg_user']['county'];}else{$_SESSION['checkout']['county']='';}
    }
    if (!isset($_SESSION['checkout']['postcode'])){
        if (isset($_SESSION['reg_user']['postcode'])){$_SESSION['checkout']['postcode']=$_SESSION['reg_user']['postcode'];}else{$_SESSION['checkout']['postcode']='';}
    }
    if (!isset($_SESSION['checkout']['country'])){
        if (isset($_SESSION['reg_user']['country'])){$_SESSION['checkout']['country']=$_SESSION['reg_user']['country'];}else{$_SESSION['checkout']['country']='';}
    }
    // delivery address
    if (!isset($_SESSION['checkout']['delivery_seperate_details'])){$_SESSION['checkout']['delivery_seperate_details']=0;}
    if (!isset($_SESSION['checkout']['delivery_name'])){$_SESSION['checkout']['delivery_name']='';}
    if (!isset($_SESSION['checkout']['delivery_address'])){$_SESSION['checkout']['delivery_address']='';}
    if (!isset($_SESSION['checkout']['delivery_address_2'])){$_SESSION['checkout']['delivery_address_2']='';}
    if (!isset($_SESSION['checkout']['delivery_city'])){$_SESSION['checkout']['delivery_city']='';}
    if (!isset($_SESSION['checkout']['delivery_county'])){$_SESSION['checkout']['delivery_county']='';}
    if (!isset($_SESSION['checkout']['delivery_postcode'])){$_SESSION['checkout']['delivery_postcode']='';}
    if (!isset($_SESSION['checkout']['delivery_country'])){$_SESSION['checkout']['delivery_country']='---';}

    if (!isset($_SESSION['checkout']['delivery_phone'])){$_SESSION['checkout']['delivery_phone']='';}

    if (!isset($_SESSION['checkout']['delivery_date_month'])){$_SESSION['checkout']['delivery_date_month']='---';}
    if (!isset($_SESSION['checkout']['delivery_date_day'])){$_SESSION['checkout']['delivery_date_day']='---';}
    if (!isset($_SESSION['checkout']['delivery_date_year'])){$_SESSION['checkout']['delivery_date_year']='---';}

    if (!isset($_SESSION['checkout']['delivery_message'])){$_SESSION['checkout']['delivery_message']='';}

    $require_address=0;
    foreach($_SESSION['cart']['products'] as $product_option_id => $product){
        if ($product['behaviour']=='Add to Cart'){$require_address=1;break;}
    }
    if (!isset($rvi_edit) && $require_address<1 && isset($_SESSION['checkout']['name']) && strlen($_SESSION['checkout']['name'])>0 && isset($_SESSION['checkout']['email']) && strlen($_SESSION['checkout']['email'])>2){

        $_SESSION['order_stage']='confirm_order';
        // redirect after form submit so browser back and refresh work without browser resend form data warning
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?order_stage=confirm_order");
        exit();
    }

    // load default country list first
    $fn_country_list_default=sys_data_dir.'/settings/country_list_default.txt';
    if (file_exists($fn_country_list_default)){
        $country_list_billing=file($fn_country_list_default);
        $country_list_delivery=$country_list_billing;
    }

    // load delivery countries
    $fn=sys_data_dir.'/settings/country_list_delivery.txt';
    $country_list_delivery[]='---';
    if (file_exists($fn)){
    	$fc=file($fn);
    	if (count($fc)>1){$country_list_delivery=array_merge($country_list_delivery,$fc);}elseif (count($fc)==1){$country_list_delivery=$fc;}
    }

    // load billing countries
    $fn=sys_data_dir.'/settings/country_list_billing.txt';
    $country_list_billing[]='---';
    if (file_exists($fn)){
    	$fc=file($fn);
    	if (count($fc)>1){$country_list_billing=array_merge($country_list_billing,$fc);}elseif (count($fc)==1){$country_list_billing=$fc;}
    }

    if (isset($rvi_name)){

    	$_SESSION['checkout']['name']=sanitize_text_input($rvi_name);
        if (!isset($_SESSION['reg_user'])){
            $_SESSION['checkout']['email']=sanitize_text_input($rvi_email);
        }
    	$_SESSION['checkout']['phone']=sanitize_text_input($rvi_phone);

    	if ($cms_settings['checkout']['dob_required']>0){
    		$_SESSION['checkout']['dob_month']=$rvi_dob_month;
    		$_SESSION['checkout']['dob_day']=$rvi_dob_day;
    		$_SESSION['checkout']['dob_year']=$rvi_dob_year;
    	}

    	$_SESSION['checkout']['address']=sanitize_text_input($rvi_address);
    	$_SESSION['checkout']['address_2']=sanitize_text_input($rvi_address_2);
    	$_SESSION['checkout']['city']=sanitize_text_input($rvi_city);
    	$_SESSION['checkout']['county']=sanitize_text_input($rvi_county);
    	$_SESSION['checkout']['postcode']=sanitize_text_input($rvi_postcode);
    	$_SESSION['checkout']['country']=sanitize_text_input($rvi_country);

    	$_SESSION['checkout']['delivery_seperate_details']=$rvi_seperate_delivery_address;
    	if ($rvi_seperate_delivery_address<1){
    		$_SESSION['checkout']['delivery_name']=$_SESSION['checkout']['name'];
    		$_SESSION['checkout']['delivery_address']=$_SESSION['checkout']['address'];
    		$_SESSION['checkout']['delivery_address_2']=$_SESSION['checkout']['address_2'];
    		$_SESSION['checkout']['delivery_city']=$_SESSION['checkout']['city'];
    		$_SESSION['checkout']['delivery_county']=$_SESSION['checkout']['county'];
    		$_SESSION['checkout']['delivery_postcode']=$_SESSION['checkout']['postcode'];
    		$_SESSION['checkout']['delivery_country']=$_SESSION['checkout']['country'];
    	}else{
    		$_SESSION['checkout']['delivery_name']=sanitize_text_input($rvi_delivery_name);
    		$_SESSION['checkout']['delivery_address']=sanitize_text_input($rvi_delivery_address);
    		$_SESSION['checkout']['delivery_address_2']=sanitize_text_input($rvi_delivery_address_2);
    		$_SESSION['checkout']['delivery_city']=sanitize_text_input($rvi_delivery_city);
    		$_SESSION['checkout']['delivery_county']=sanitize_text_input($rvi_delivery_county);
    		$_SESSION['checkout']['delivery_postcode']=sanitize_text_input($rvi_delivery_postcode);
    		$_SESSION['checkout']['delivery_country']=sanitize_text_input($rvi_delivery_country);
    	}

        if ($cms_settings['checkout']['delivery_phone_field']>0){$_SESSION['checkout']['delivery_phone']=sanitize_text_input($rvi_delivery_phone);}
    	if ($cms_settings['checkout']['scheduled_delivery']>0){
    		$_SESSION['checkout']['delivery_date_month']=$rvi_delivery_date_month;
    		$_SESSION['checkout']['delivery_date_day']=$rvi_delivery_date_day;
    		$_SESSION['checkout']['delivery_date_year']=$rvi_delivery_date_year;
    	}
    	if ($cms_settings['checkout']['delivery_message']>0){$_SESSION['checkout']['delivery_message']=sanitize_text_input($rvi_delivery_message);}

    	// check shipping address values
    	if (strlen($rvi_name)<3){$_SESSION['form']['checkout']['warning'][]='Please enter your name';}
    	// check email address
        if (!isset($_SESSION['reg_user'])){
			require_once(cms_root_dir.'scripts/emailval.php');
			if (MailVal($rvi_email,2) || strlen($rvi_email)>128){$_SESSION['form']['checkout']['warning'][]="Please enter your email address";}
			if (!isset($_SESSION['checkout']['id'])){ // not sure why registered email check is in this if statemtent
                if (email_registered($rvi_email)){$_SESSION['form']['checkout']['warning'][]="A registered account exists under this email address. Please login above.";}
			}
        }
    	// check phone number
        if ($require_address>0){
    	    $clearchars=array('-',',',' ','-','+','(',')');
    	    if(intval(str_replace($clearchars,'',$rvi_phone))<10000){$_SESSION['form']['checkout']['warning'][]='Please enter your phone number';}
    	    // check billing details
    	    if (strlen($rvi_address)<3){$_SESSION['form']['checkout']['warning'][]='Please enter your billing address';}
    	    if (strlen($rvi_city)<3){$_SESSION['form']['checkout']['warning'][]='Please enter your town/city under billing address';}
    	    if (strlen($rvi_county)<3){$_SESSION['form']['checkout']['warning'][]='Please enter your county under billing address';}
    	    if ($rvi_country=='---'){$_SESSION['form']['checkout']['warning'][]='Please select your country under billing address';}
    	    // check delivery details
          	if($rvi_seperate_delivery_address>0){
          		if (strlen($rvi_delivery_name)<3){$_SESSION['form']['checkout']['warning'][]='Please enter name under delivery details';}
          		if (strlen($rvi_delivery_address)<2){$_SESSION['form']['checkout']['warning'][]='Please enter an address under delivery details';}
          		if (strlen($rvi_delivery_city)<2){$_SESSION['form']['checkout']['warning'][]='Please enter town/city under delivery details';}
          		if (strlen($rvi_delivery_county)<2){$_SESSION['form']['checkout']['warning'][]='Please enter county under delivery details';}
          		if ($rvi_delivery_country=='---'){$_SESSION['form']['checkout']['warning'][]='Please select a country under delivery details';}
          	}
          	else{
          		// check if billing country is a valid delivery country
          		foreach ($country_list_delivery as $line){
          			if (trim($rvi_country)==trim($line)){$valid_delivery_country=TRUE;break;}
          		}
          		if (!isset($valid_delivery_country) && $rvi_country!='---'){
                    $_SESSION['form']['checkout']['warning'][]=$rvi_country.' is not a valid delivery country';
                }

          	}
        }

    	// check date of birth
    	if ($cms_settings['checkout']['dob_required']>0){
    		if ($rvi_dob_month=='---' || $rvi_dob_day=='---' || $rvi_dob_year=='---'){$_SESSION['form']['checkout']['warning'][]='Please enter your date of birth';}
    	}
    	// check greeting card message
    	if (isset($rvi_delivery_message) && strlen($rvi_delivery_message)>100){$_SESSION['form']['checkout']['warning'][]="Greeting card message is too long";}

    	// check terms and conditions checkbox
    	if (empty($rvi_check_tos)){$_SESSION['tos_agree']="No";$_SESSION['form']['checkout']['warning'][]="You must agree to the terms of service to continue";}else{$_SESSION['tos_agree']="Yes";}

    	// go to next order stage if no warnings
    	if (!isset($_SESSION['form']['checkout']['warning'])){
            $_SESSION['order_stage']='shipping';
            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header('HTTP/1.1 303 See Other');
            header("Location: ".cms_url."?order_stage=shipping");
            exit();
        }
        else{
          // redirect after form submit so browser back and refresh work without browser resend form data warning
          header('HTTP/1.1 303 See Other');
          header("Location: ".cms_url."?order_stage=checkout");
          exit();
        }



    }

    //if ($_SESSION['order_stage']=="confirm_order"){include("confirm_order.php");}

  	// show hide javascript
  	$page_meta.="<script>
  	function show(id) {
  		var d=document.getElementById(id);
  		d.style.display='block';
  	}
  	function hide(id) {
  		var d=document.getElementById(id);
  		d.style.display='none';
  	}
  	function open_win(page,name){toswindow=window.open(page,name,'width=350,height=380,scrollbars=1');
  	setTimeout(\"toswindow.focus();\",10);}
  	</script>";


  	$page_content['main'].="<div class=\"checkout\"><h1>".$txt['Checkout']."</h1>";

  	// load checkout text/instructions
  	$checkout_text_fn=sys_data_dir.'/settings/checkout.html';
  	if (file_exists($checkout_text_fn)){
  		$text=file_get_contents($checkout_text_fn);
  		if (strlen($text)>0){$page_content['main'].="<div>$text</div>";}
  	}


  		//$page_content['main'].='<table class=\"basic_table\">';

  		if (!isset($_SESSION['reg_user'])){

    		// display returning customer login
    		$page_content['main'].="<fieldset><legend class=\"checkout_legend\">".$txt['checkout_returning_customer']."</legend>
    		<p class=\"small_note\">".$txt['Login_instruction']." <a href=\"".cms_url."?forgot_password\">Forgot Password</a></p>";
    		// display login warnings
      		if (isset($_SESSION['form']['login']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['login']['warning']);}

    		//if(!isset($rvi_email)){$rvi_email='';}
    		//if(!isset($rvi_password)){$rvi_password='';}

    		$page_content['main'].="<form class=\"cms_form\" name=\"customer_login_form\" method=\"post\" action=\"".cms_url."?order_stage=checkout\">

    		<div class=\"form_row form_row_medium\"><div class=\"form_row\" style=\"flex: 0 1 21em\"><label for=\"email\">".$txt['Email'].":</label><input type=\"text\" id=\"email\" name=\"email\" value=\"".(isset($_SESSION['form']['login']['email']) ? $_SESSION['form']['login']['email'] : "")."\" ></div><div class=\"form_row\" style=\"flex: 0 1 21em\"><label for=\"password\">".$txt['Password'].":</label> <input type=\"password\" id=\"password\" name=\"password\" value=\"".(isset($rvi_password) ? $rvi_password : '')."\"></div></div>
            <div class=\"form_row\"><label><input type=\"checkbox\" name=\"remember_login\"".(isset($_SESSION['form']['login']['remember_me']) ? " checked" : "")." /> ".$txt['Remember_Me']."</label><input type=\"hidden\" name=\"ulogin[]\" /><button type=\"submit\" class=\"btn btn_login\">".$txt['btn_login']."</button></div>

    		</form>
    		</fieldset>
    		<div style=\"font-size: 1.5em; font-weight: bold; text-align:center;margin-top: 1em\">OR</div>";
    		$order_details_legend=$txt['checkout_new_customer'];
  		}
  		else{
  			$order_details_legend='Order Details';
            // display success login warnings
      		if (isset($_SESSION['form']['login']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['login']['warning_green'],'green');}
  		}


  		$page_content['main'].="<fieldset><legend class=\"checkout_legend\">$order_details_legend</legend>
  		<form class=\"cms_form\" name=\"checkout_info\" action=\"".cms_url."?order_stage=checkout\" method=\"post\">";

        if (isset($_SESSION['reg_user'])){
            $page_content['main'].="<p>Welcome back ".short_name($_SESSION['reg_user']['name'])." - ".$txt['Checkout_message']."</p>";
        }
        else{
  		    $page_content['main'].="<p>".$txt['Checkout_message']."</p>";
        }

  		// display warnings
  		if (isset($_SESSION['form']['checkout']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['checkout']['warning']);}

  		$page_content['main'].="<br><a name=\"contact_details\"></a><h3>Your Details</h3>
        <div class=\"form_row form_row_medium\"><label>Name:</label><input type=\"text\" name=\"name\" value=\"".$_SESSION['checkout']['name']."\"></div>";

        if (isset($_SESSION['reg_user'])){$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label>".$_SESSION['reg_user']['email']." (<a href=\"".cms_url."?logout\">Logout</a>)</div>";}
        else{$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label><input type=\"text\" name=\"email\" value=\"".$_SESSION['checkout']['email']."\"></div>";}

    	$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Phone:</label><input type=\"text\" name=\"phone\" value=\"".$_SESSION['checkout']['phone']."\"></div>";

		if ($cms_settings['checkout']['dob_required']>0){
			$page_content['main'].="<br><h3>Other Details</h3>";
    		$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Date of Birth:</label><select name=\"dob_month\">";
    		  $option=array('---','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if ($_SESSION['checkout']['dob_month']==$option[$option_num]){
    					$page_content['main'].='<option selected>'.$option[$option_num].'</option>';
    				}
    				else{
    					$page_content['main'].='<option>'.$option[$option_num].'</option>';
    				}
    			}
    			$page_content['main'].='</select>
    		<select name="dob_day">';
    		unset($option);
    		  $option[0]='---';
    		  for ($day=1; $day<=31; $day++){$option[]=$day;}
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if ($_SESSION['checkout']['dob_day']==$option[$option_num]){
    					$page_content['main'].="<option selected>".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].='</select>
    		  <select name="dob_year">';
    		  unset($option);
    		  $option[0]='---';
    		  for ($year=intval(date("Y",time())); $year>=1900; $year--){$option[]=$year;}
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if ($_SESSION['checkout']['dob_year']==$option[$option_num]){
    					$page_content['main'].="<option selected>".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].="</select></div>";
			}


        $page_content['main'].="<br><h3>Billing Address</h3>
  		<div class=\"form_row form_row_medium\"><label>Address:</label><input type=\"text\" name=\"address\"  value=\"".$_SESSION['checkout']['address']."\"></div>
        <div class=\"form_row form_row_medium\"><label>&nbsp;</label><input type=\"text\" name=\"address_2\" value=\"".$_SESSION['checkout']['address_2']."\"></div>
        <div class=\"form_row form_row_medium\"><label>Town/City:</label><input type=\"text\" name=\"city\" value=\"".$_SESSION['checkout']['city']."\"></div>
  		<div class=\"form_row form_row_medium\"><label>County:</label><input type=\"text\" name=\"county\" value=\"".$_SESSION['checkout']['county']."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Post Code:</label><input type=\"text\" name=\"postcode\" value=\"".$_SESSION['checkout']['postcode']."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Country:</label><select style=\"max-width: 145px\" name=\"country\">";
  	    $option=$country_list_billing;
  	    $option_qty=count($option);
  	    for ($option_num=0;$option_num<$option_qty;$option_num++){
 		    $option[$option_num]=trim($option[$option_num]);
			if ($_SESSION['checkout']['country']==$option[$option_num]){
				$page_content['main'].="<option selected>".$option[$option_num]."</option>";
			}
			else{
				$page_content['main'].="<option>".$option[$option_num]."</option>";
			}
		}
		$page_content['main'].="</select></div>
        <br>
		<a name=\"delivery_address\"></a><h3>Delivery Address</h3>
        <div style=\"margin: 1em\">
  		<input type=\"radio\" name=\"seperate_delivery_address\" value=\"0\" onclick=\"javascript:hide('delivery_details');\""; if ($_SESSION['checkout']['delivery_seperate_details']<1){$page_content['main'].=" checked";} $page_content['main'].="> Same as billing address<br>
  		<input type=\"radio\" name=\"seperate_delivery_address\" value=\"1\" class=\"extend_page\" onclick=\"javascript:show('delivery_details');\""; if ($_SESSION['checkout']['delivery_seperate_details']>0){$page_content['main'].=" checked";} $page_content['main'].="> Specify a separate delivery address
        </div>
  		<div id=\"delivery_details\" "; if ($_SESSION['checkout']['delivery_seperate_details']<1){$page_content['main'].="style=\"display:none;\"";}else{$page_content['main'].="style=\"display:block;\"";} $page_content['main'].=">
  		<div class=\"form_row form_row_medium\"><label>Name:</label><input type=\"text\" name=\"delivery_name\" value=\"".$_SESSION['checkout']['delivery_name']."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Address:</label><input type=\"text\" name=\"delivery_address\" value=\"".$_SESSION['checkout']['delivery_address']."\"></div>
        <div class=\"form_row form_row_medium\"><label>&nbsp;</label><input type=\"text\" name=\"delivery_address_2\" value=\"".$_SESSION['checkout']['delivery_address_2']."\"></div>
        <div class=\"form_row form_row_medium\"><label>Town/City:</label><input type=\"text\" name=\"delivery_city\" value=\"".$_SESSION['checkout']['delivery_city']."\"></div>
  		<div class=\"form_row form_row_medium\"><label>County:</label><input type=\"text\" name=\"delivery_county\" value=\"".$_SESSION['checkout']['delivery_county']."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Post Code:</label><input type=\"text\" name=\"delivery_postcode\" value=\"".$_SESSION['checkout']['delivery_postcode']."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Country:</label><select style=\"max-width: 145px\" name=\"delivery_country\">";
  	  $option=$country_list_delivery;
  	  $option_qty=count($option);
  	  for ($option_num=0;$option_num<$option_qty;$option_num++){
            $option[$option_num]=trim($option[$option_num]);
			if ($_SESSION['checkout']['delivery_country']==$option[$option_num]){
				$page_content['main'].="<option selected>".$option[$option_num]."</option>";
			}
			else{
				$page_content['main'].="<option>".$option[$option_num]."</option>";
			}
		}
		$page_content['main'].="</select></div>
        </div>";

        if ($cms_settings['checkout']['delivery_phone_field']>0 || $cms_settings['checkout']['scheduled_delivery']>0 || $cms_settings['checkout']['delivery_message']){

            $page_content['main'].="<h3>Delivery Options</h3>";

            if ($cms_settings['checkout']['delivery_phone_field']>0){
      			$page_content['main'].="<p class=\"small_note\">Specify a contact phone number that may be used by the delivery person if needed when delivering your order.</p>
                <div class=\"form_row form_row_medium\"><label>Phone:</label><input type=\"text\" name=\"delivery_phone\" value=\"".$_SESSION['checkout']['delivery_phone']."\"></div>";
      		}


      		if ($cms_settings['checkout']['scheduled_delivery']>0){
      			$page_content['main'].="<p class=\"small_note\">If you have a desired delivery date please specify below otherwise leave blank and we'll deliver as soon as possible.</p>
                <div class=\"form_row form_row_medium\"><label>Date Required:</label><select name=\"delivery_date_month\">";
      			  $option=array("---","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
      			  $option_qty=count($option);
      			  for ($option_num=0;$option_num<$option_qty;$option_num++){
      					if ($_SESSION['checkout']['delivery_date_month']==$option_num){
      						$page_content['main'].="<option value=\"$option_num\" selected>".$option[$option_num]."</option>";
      					}
      					else{
      						$page_content['main'].="<option value=\"$option_num\">".$option[$option_num]."</option>";
      					}
      				}
      				$page_content['main'].="</select>
      			<select name=\"delivery_date_day\">";
      			unset($option);
      			  $option[0]="---";
      			  for ($day=1; $day<=31; $day++){$option[]=$day;}
      			  $option_qty=count($option);
      			  for ($option_num=0;$option_num<$option_qty;$option_num++){
      					if ($_SESSION['checkout']['delivery_date_day']==$option[$option_num]){
      						$page_content['main'].="<option selected>".$option[$option_num]."</option>";
      					}
      					else{
      						$page_content['main'].="<option>".$option[$option_num]."</option>";
      					}
      				}
      				$page_content['main'].="</select>
      			  <select name=\"delivery_date_year\">";
      			  unset($option);
      			  $option[0]="---";
      			  $this_year=date("Y",time());
      			  for ($year=$this_year; $year<=$this_year+1; $year++){$option[]=$year;}
      			  $option_qty=count($option);
      			  for ($option_num=0;$option_num<$option_qty;$option_num++){
      					if ($_SESSION['checkout']['delivery_date_year']==$option[$option_num]){
      						$page_content['main'].="<option selected>".$option[$option_num]."</option>";
      					}
      					else{
      						$page_content['main'].="<option>".$option[$option_num]."</option>";
      					}
      				}
      		$page_content['main'].="</select></div>";
      		}

      		if ($cms_settings['checkout']['delivery_message']>0){
      			$page_content['main'].="<p class=\"small_note\">If you would like to include a greeting card message please enter it below.</p>
                <div class=\"form_row form_row_medium\"><label>Greeting Card:</label><textarea name=\"delivery_message\" class=\"delivery_message\">".$_SESSION['checkout']['delivery_message']."</textarea></div>";
      		}

        }

  			$page_content['main'].="<div class=\"form_row\"><label><input type=\"checkbox\" name=\"check_tos\" value=\"checkbox\" ";
    if (isset($_SESSION['tos_agree']) && $_SESSION['tos_agree']=="Yes"){$page_content['main'].="checked";}
    $page_content['main'].=" /> I have read and agree to the <a href=\"javascript:open_win('".cms_root_url."sys/data/terms_full.html','Terms')\">terms &amp; conditions</a></label> <button type=\"submit\" class=\"btn btn_checkout\">".$txt['btn_checkout']."</button></div>
  		</form></fieldset>
        </div>";



	?>