<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // output news detail
	$page_title.=cms_site_name." Sitemap";

    $page_content['main'].="<h1>Sitemap</h1>";

    $page_content['main'].=sitemap_display_categories(0,0,1);


    function sitemap_display_categories($parent_category_id, $level, $type) {

    	$categories=get_categories($parent_category_id,"name",$type);
    	if (!is_array($categories)){return false;}

    	$content='';
    	$indent='';
    	if ($level>0){
    	  for ($i=0; $i<$level; $i++){$indent.="- &nbsp;&nbsp;";}
    	}
        if (strlen($indent)>0){$indent='<span style="color: #b2b2b2">'.$indent.'</span>';}

        $content.="<ul>";

    	foreach ($categories as $category_id => $value){

    		if ($type==$value['type']){

              if ($category_details=get_category_details($category_id)){

                  if (!isset($category_details['user_group']) || !in_array(0,$category_details['user_group'])){continue;}
                  if (isset($category_details['in_sitemap']) && $category_details['in_sitemap']<1){continue;}

                  $content.="<li><a href=\"".category_url($category_details['category_id'],'1',$category_details['slug'])."\">".$category_details['name']."</a>";

                  /*
                  // output category sub pages to sitemap
                  if ($category_details['listing_type']==0){$items_type='products';}
                  elseif ($category_details['listing_type']==1){$items_type='listings';}

            	  if ($items=get_items($items_type,$category_id,'1')){$item_count=count($items);}else{$item_count=0;}
                  if ($item_count>0){
                      $items_per_page=$category_details['rows']*$category_details['cols'];
                      $number_of_pages=ceil($item_count/$items_per_page);
                      if ($number_of_pages>1){
                          for ($page_num=2; $page_num<=$number_of_pages; $page_num++){
                              $content.=" <a href=\"".category_url($category_details['category_id'],$page_num,$category_details['slug'])."\">".$page_num."</a>";
                          }
                      }
                  }
                  unset($items,$item_count,$page_num);
                  */

                  $content.="</li>";

                  // call this function again to display this categories child categories if any
        			if ($type>0 && $value['child_category_count']>0){$content.=sitemap_display_categories($category_id, $level+1, $type);}

              }
          }

    	}
        $content.="</ul>";
       return $content;
    }

//if (admin_level()>9){exit;}
?>
