<?php

    // ini_set("memory_limit","100M");
	// ini_set("max_execution_time","3600");

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}
    if (!isset($cms_settings['users']['profile_pages']) || $cms_settings['users']['profile_pages']<1){return;}

	if ($customer_details=get_item_details('customer',$rvi_profile)){

        // $page_template=$product_details['template'];
        $last_message_fn=sys_data_dir.'/customers/'.$customer_details['id'].'/last_message.txt';

		// page meta tags
        $page_meta.="<link rel=\"canonical\" href=\"".item_url('customer',$rvi_profile)."\" />";

		// jquery light box includes
		$page_meta.="<script type=\"text/javascript\" src=\"".cms_root_url."plugins/slimbox-2.04/js/slimbox2.js\"></script>
		<link rel=\"stylesheet\" href=\"".cms_root_url."plugins/slimbox-2.04/css/slimbox2.css\" type=\"text/css\" media=\"screen\" />";


		// output product detail
		if ($page_title==''){$page_title.='Profile page of '.htmlentities($customer_details['name'],ENT_COMPAT,'UTF-8');}

		$page_content['main'].="<div class=\"profile_frame\"><div class=\"profile_detail\">";



        $tn_size_x=$cms_settings['img']['width_main'];
        $tn_size_y=$cms_settings['img']['height_main'];

        $image_content='<div class=\"img_group\" style="width: '.$tn_size_x.'px">';


        if (!isset($customer_details['profile_image']) || !file_exists(sys_data_dir.'/customers/'.$customer_details['id'].'/'.$customer_details['profile_image'])){
            $image_fn='no-profile-pic.png';
            $image_path=cms_theme_dir.'images/users/';
            if (!file_exists($image_path.$image_fn)){$image_path=cms_root_dir.'themes/default/images/users/';}
        }
        else{
            $image_fn=$customer_details['profile_image'];
            $image_path=sys_data_dir.'/customers/'.$customer_details['id'].'/';
        }

		// check if correct size image exists and create one if it doesn't
		$thumbnail_fn=$tn_size_x."x".$tn_size_y.'_p'.$customer_details['id'].'_'.safe_file_name($image_fn);
		if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
			createthumb($image_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1);
		}

        if (file_exists(sys_image_dir.'/'.$thumbnail_fn)){

            // check if correct size zoom-in image exists and create one if it doesn't
            $tn_size_zoom_x=$cms_settings['img']['zoom_width_tn'];
            $tn_size_zoom_y=$cms_settings['img']['zoom_height_tn'];
            // override thumbnail sizes if original file is smaller (half difference in size so not too big and not too small)
            $image_size=getimagesize($image_path.$image_fn);
            if ($image_size[0]<$tn_size_zoom_x && $image_size[1]<$tn_size_zoom_y){
                $tn_size_zoom_x=intval(($tn_size_zoom_x-$image_size[0])/2);
                $tn_size_zoom_y=intval(($tn_size_zoom_y-$image_size[1])/2);
            }
            $thumbnail_zoom_fn=$tn_size_zoom_x."x".$tn_size_zoom_y.'_p'.$customer_details['id'].'_'.$image_fn;
            if (!file_exists(sys_image_dir.'/'.$thumbnail_zoom_fn)){
                createthumb($image_path.$image_fn,sys_image_dir.'/'.$thumbnail_zoom_fn,$tn_size_zoom_x,$tn_size_zoom_y,1);
            }

            // get size of thumbnail image
            $image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);

            $link_title='Profile Pic - '.$customer_details['name'];
            $image_content.="<div class=\"main_img\"><a href=\"".cms_image_url.$thumbnail_zoom_fn."\" rel=\"lightbox-product\" title=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\"><img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" /></a></div>";

        }

        // display link icons
        if (isset($customer_details['website']) || isset($customer_details['facebook']) || isset($customer_details['twitter']) || isset($customer_details['youtube'])){
            $image_content.='<div style="text-align: center; margin: 8px 0 8px 0">';
            if (isset($customer_details['website']) && strlen($customer_details['website'])>2){$image_content.='<a href="'.$customer_details['website'].'" rel="external nofollow" target="_blank"><img src="'.$display_theme_url.'images/users/link_web.png" width="38" height="38" alt=\"Website Link\" /></a>';}
            if (isset($customer_details['facebook']) && strlen($customer_details['facebook'])>2){$image_content.='<a href="'.$customer_details['facebook'].'" rel="external nofollow" target="_blank"><img src="'.$display_theme_url.'images/users/link_facebook.png" width="38" height="38" alt=\"Facebook Link\" /></a>';}
            if (isset($customer_details['twitter']) && strlen($customer_details['twitter'])>2){$image_content.='<a href="'.$customer_details['twitter'].'" rel="external nofollow" target="_blank"><img src="'.$display_theme_url.'images/users/link_twitter.png" width="38" height="38" alt=\"Twitter Link\" /></a>';}
            if (isset($customer_details['youtube']) && strlen($customer_details['youtube'])>2){$image_content.='<a href="'.$customer_details['youtube'].'" rel="external nofollow" target="_blank"><img src="'.$display_theme_url.'images/users/link_youtube.png" width="38" height="38" alt=\"Yutube Link\" /></a>';}
            $image_content.='</div>';
        }


        $image_content.='</div>';

        // display image content
        $page_content['main'].=$image_content;


        // get messages for this user
        $message_status=1;
        $search_messages['recipient_id']=$customer_details['id'];
        if (!isset($_SESSION['reg_user']) || $_SESSION['reg_user']['id']!=$customer_details['id'] || !isset($rvi_myaccount)){$search_messages['rating']='any';}
        elseif ($_SESSION['reg_user']['id']==$customer_details['id'] && isset($rvi_messages) && $rvi_messages=='sent'){
            unset($search_messages['recipient_id']);
            $search_messages['customer_id']=$customer_details['id'];
            // any status for sent messages
            $message_status=null;
        }
        if ($messages=get_items('messages',null,$message_status,null,null,$search_messages,null,null,array('rating'))){$messages_count=count($messages);}else{$messages_count=0;}

        // calculate average feedback score
        $total_feedback_score=0;
        $feedback_qty=0;
        for ($item_num=0; $item_num<$messages_count; $item_num++){
            if (isset($messages[$item_num]['rating']) && $messages[$item_num]['rating']>0){
                $total_feedback_score=$total_feedback_score+$messages[$item_num]['rating'];
                $feedback_qty++;
            }
        }
        if ($feedback_qty>0){$total_feedback_score=ceil($total_feedback_score/$feedback_qty);}

        // calculate number of days since update
        if(isset($customer_details['last_login'])){
            $modified_time_midnight=mktime(0, 0, 0, date('m',$customer_details['last_login']), date('d',$customer_details['last_login']), date('Y',$customer_details['last_login']));
            $num_of_days=intval((time()-$modified_time_midnight)/86400);
            if ($num_of_days<1){$last_online='Today';}
            elseif ($num_of_days<2){$last_online='Yesterday';}
            elseif ($num_of_days<6){$last_online=$num_of_days.' days ago';}
            else {$last_online=date('jS F Y',$customer_details['last_login']);}
        }else{$last_online='N/A';}

        $location='';
        if (isset($customer_details['city']) && strlen($customer_details['city'])>1){$location.=$customer_details['city'];}
        if (isset($customer_details['county']) && strlen($customer_details['county'])>1){
            if ($location!=''){$location.=', '.$customer_details['county'];}
            else {$location=$customer_details['county'];}
        }
        if ($location=='' && isset($customer_details['country']) && $customer_details['country']!='---'){$location=$customer_details['country'];}
        if ($location==''){$location='Unknown';}

        $page_content['main'].='<div style=\"margin-left: '.($cms_settings['img']['width_main']+15).'px"><h1>'.htmlentities($customer_details['name'],ENT_COMPAT,'UTF-8').'</h1>
        <div><span style="font-weight: bold; color: #4b6172">Joined:</span> '.date('d M Y',$customer_details['registered_timestamp']).'<br />
        <span style="font-weight: bold; color: #4b6172">Last Online:</span> '.$last_online.'<br />
        <span style="font-weight: bold; color: #4b6172">Location:</span> '.$location.'</div>';

        if (isset($_SESSION['reg_user']) && $_SESSION['reg_user']['id']!=$customer_details['id']){
            $page_content['main'].='<div style="margin: 8px 0 8px 0"><a href="'.cms_url.'?profile='.$customer_details['id'].'&amp;message=feedback"><img src="'.$display_theme_url.'images/stars'.$total_feedback_score.'.png" width="140" height="30" alt="Feedback score of '.$total_feedback_score.'" /></a></div>';
            $page_content['main'].='<div><a href="'.cms_url.'?search[customer_id]='.$customer_details['id'].'">View Listings</a> - <a href="'.cms_url.'?profile='.$customer_details['id'].'&amp;message=feedback">Give Feedback</a> - <a href="'.cms_url.'?profile='.$customer_details['id'].'&amp;message">Private Message</a></div>';
        }
        elseif (isset($_SESSION['reg_user']) && $_SESSION['reg_user']['id']==$customer_details['id']){
            $page_content['main'].='<div style="margin: 4px 0 4px 0"><img src="'.$display_theme_url.'images/stars'.$total_feedback_score.'.png" width="140" height="30" alt="Feedback score of '.$total_feedback_score.'" /></div>';
            $page_content['main'].='<div><a href="'.cms_url.'?search[customer_id]='.$customer_details['id'].'">View My Active Listings</a> - <a href="'.cms_url.'?myaccount=listings">Manage My Listings</a></div>';
        }
        else{
            $page_content['main'].='<div style="margin: 4px 0 4px 0"><img src="'.$display_theme_url.'images/stars'.$total_feedback_score.'.png" width="140" height="30" alt="Feedback score of '.$total_feedback_score.'" /></div>';
            $page_content['main'].='<div><a href="'.cms_url.'?search[customer_id]='.$customer_details['id'].'">View Listings</a> - <a href="'.cms_url.'?login">Give Feedback</a> - <a href="'.cms_url.'?login">Private Message</a></div>';
        }

        if (isset($customer_details['bio']) && strlen($customer_details['bio'])>0){$page_content['main'].='<div style="margin-top: 8px"><span style="font-weight: bold; color: #4b6172">About Me:</span> '.$customer_details['bio'].'</div>';}

  	   $page_content['main'].='</div><br /><hr /><div style="clear: both"><!-- - --></div>';


        if (isset($rvi_message) && isset($_SESSION['reg_user']) && $_SESSION['reg_user']['id']!=$customer_details['id']){

           if (isset($rvi_submit_message)){

                $rvi_message_text=sanitize_text_input($rvi_message_text);

    		    if (strlen($rvi_message_text)<10){$_SESSION['form']['user_profile']['warning'][]='Message is too short.';}
                else{
                    // check for spam in message
          			$spam_words=array('cialis','viagra','xanax','tramadol','replicawatch','freeringtone','[/url]','lesbian','porn','penis');
          			foreach ($spam_words as $spam_word){
          				if (strpos(strtolower($rvi_message_text),$spam_word)!==FALSE){$_SESSION['form']['user_profile']['warning'][]='Message contains spam filtered words. Please remove the word &quot;'.$spam_word.'&quot;.';break;}
          			}
                    $swear_words=array('fuck');
          			foreach ($swear_words as $swear_word){
          				if (strpos(strtolower($rvi_message_text),$swear_word)!==FALSE){$_SESSION['form']['user_profile']['warning'][]='Message contains offensive words. Please edit your message.';break;}
          			}
                    $limit_words=array('@','http','www','.com','.net','.biz','.info','.org','.ru');
                    foreach ($limit_words as $limit_word){
          			    if (substr_count($rvi_message_text,$limit_word)>2){$_SESSION['form']['user_profile']['warning'][]='Spam filter found too many &quot;'.$limit_word.'&quot; in message. Please edit your message.';break;}
                    }
                }

    		    if (!isset($_SESSION['form']['user_profile']['warning'])){

                      $message_details['timestamp']=time();
                      $message_details['id']=$message_details['timestamp'].rand(100,999);
                      $message_details['item_type']='message';
                      $message_details['status']=new_message_status; // 0=awaiting moderation, 1=approved, 2=spam
                      $message_details['message']=$rvi_message_text;
                      $message_details['recipient_id']=$customer_details['id'];
                      $message_details['ip_address']=$_SERVER['REMOTE_ADDR'];
                      $message_details['customer_id']=$_SESSION['reg_user']['id'];
                      if (isset($rvi_rating)){$message_details['rating']=$rvi_rating;}else{$message_details['rating']=0;}

                      save_item_details($message_details);
                      update_item_list_file('messages',array($message_details['id']),'add');

                      // send new message email to user
                      if ($message_details['status']>0){

                          // update new messages file
                          if (file_exists($last_message_fn)){$last_message_timestamp=trim(file_get_contents($last_message_fn));}

                          // only send one email notification per 24hrs unless recipient has logged in and checked messages and then reset
                          if (!isset($last_message_timestamp) || $message_details['timestamp']-$last_message_timestamp>86400){

                              $fo=fopen($last_message_fn,'w');
                              fwrite($fo,$message_details['timestamp']);
                              fclose($fo);

                              require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

                              $mail = new PHPMailer();

                              // send mail via smtp if set in config file
                              if (defined('smtp_host')){
                                  $mail->IsSMTP(); // send via SMTP
                                  $mail->SMTPAuth = true; // turn on SMTP authentication
                                  $mail->SMTPSecure = 'ssl';
                                  $mail->Username = smtp_username; // SMTP username
                                  $mail->Password = smtp_password; // SMTP password
                                  $mail->Host       = smtp_host; // SMTP server
                                  $mail->Port       = smtp_port; // SMTP server
                              }

                              // send confirmation email to user
                              $mail->From = $cms_settings['config']['site_email'];
                              $mail->FromName = cms_site_name;
                              $mail->AddAddress($customer_details['email']);

                              $mail->Subject = cms_site_name." - You have new messages";
                              $mail->Body    = "Hi ".$customer_details['name'].",\n\nYou have new unread messages! Use the link below to login and read your messages.\n\n".cms_url."?myaccount=profile\n\n".cms_site_name."\n".cms_url;

                              if ($mail->Send()){update_log('New message notification email sent to user '.$customer_details['id']);}else{update_log('Sending Failed: New message notification email to user '.$customer_details['id']);}

                          }
                      }

                      $_SESSION['form']['user_profile']['warning_green'][]='Your message has been sent</p>';

                      update_admin_notify_log('New user message');

                      // redirect after form submit so browser back and refresh work without browser resend form data warning
                      header('HTTP/1.1 303 See Other');
                      header("Location: ".cms_url."?profile=".$customer_details['id']."&message");
                      exit();

    		    }
            }

            if ($rvi_message=='feedback'){

                $page_content['main'].="<h3>Leave feedback for ".$customer_details['name']."</h3>";

                // display warnings
                if (isset($_SESSION['form']['user_profile']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['user_profile']['warning']);}
                elseif (isset($_SESSION['form']['user_profile']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['user_profile']['warning_green'],'green');}

  				$page_content['main'].="<form action=\"#message_form\" method=\"post\"><table>
                <tr><td width=\"80\"><b>From:</b></td><td width=\"160\"><input type=\"text\" name=\"\" value=\"".$_SESSION['reg_user']['name']." (".$_SESSION['reg_user']['email'].")\" disabled=\"disabled\" /> (<a href=\"".cms_url."?logout\">Logout</a>)</td></tr>
                <tr><td><b>Rating:</b></td><td><select name=\"rating\"><option value=\"5\">5 - Great</option><option value=\"4\">4</option><option value=\"3\">3</option><option value=\"2\">2</option><option value=\"1\">1 - Poor</option></select></td></tr>
  				<tr><td valign=\"top\"><b>Feedback:</b></td><td><textarea name=\"message_text\" cols=\"45\" rows=\"5\">".(isset($rvi_message_text) ? $rvi_message_text : '')."</textarea></td></tr>
  				<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Post My Feedback\" name=\"submit_message\" /></td></tr>
  				</table></form><hr />";
            }
            else{

                $page_content['main'].="<h3>Send a private message to ".$customer_details['name']."</h3>";

                // display warnings
                if (isset($_SESSION['form']['user_profile']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['user_profile']['warning']);}
                elseif (isset($_SESSION['form']['user_profile']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['user_profile']['warning_green'],'green');}

                $page_content['main'].="<form action=\"#message_form\" method=\"post\"><table>
                <tr><td  width=\"80\"><b>From:</b></td><td width=\"160\"><input type=\"text\" name=\"\" value=\"".$_SESSION['reg_user']['name']." (".$_SESSION['reg_user']['email'].")\" disabled=\"disabled\" /> (<a href=\"".cms_url."?logout\">Logout</a>)</td></tr>
                <tr><td valign=\"top\"><b>Message:</b></td><td><textarea name=\"message_text\" cols=\"45\" rows=\"5\">".(isset($rvi_message_text) ? $rvi_message_text : '')."</textarea></td></tr>
                <tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Send\" name=\"submit_message\" /></td></tr>
                </table></form><hr />";
            }

        }



        $messages_content='<table width="100%" cellpadding="4" cellspacing="3">';

            if (isset($rvi_myaccount) && isset($_SESSION['reg_user']) && $_SESSION['reg_user']['id']==$customer_details['id']){

                if (file_exists($last_message_fn)){unlink($last_message_fn);}

                if (isset($rvi_messages) && $rvi_messages=='sent'){
                    $messages_content.='<tr><td colspan="2"><h2>Sent Messages</h2><p><a href="'.cms_url.'?myaccount=profile">Message Inbox</a> - <a href="'.cms_url.'?myaccount=profile&amp;messages=sent">Sent Messages</a></p></td></tr>';
                    if ($messages_count<1){$messages_content.='<tr><td colspan="2"><p>You have no sent messages.</p></td></tr>';}
                }
                else{
                    $messages_content.='<tr><td colspan="2"><h2>Message Inbox</h2><p><a href="'.cms_url.'?myaccount=profile">Message Inbox</a> - <a href="'.cms_url.'?myaccount=profile&amp;messages=sent">Sent Messages</a></p></td></tr>';
                    if ($messages_count<1){$messages_content.='<tr><td colspan="2"><p>You have no messages.</p></td></tr>';}
                }



            }else{
                if ($messages_count>0){$messages_content.='<tr><td colspan="2"><h2>Feedback</h2><p>View other users feedback on this user below.</p></td></tr>';}
                else{$messages_content.='<tr><td colspan="2"><h2>Feedback</h2><p>This user has not received any feedback yet.</p></td></tr>';}
            }



            if ($messages_count>0){

			    $items_per_page=7;

			    $number_of_pages=ceil($messages_count/$items_per_page);

			    if (isset($rvi_page)){$display_page_num=$rvi_page;}
			    if (!isset($display_page_num) || $display_page_num<1){$display_page_num=1;}
			    if ($display_page_num>$number_of_pages){$display_page_num=$number_of_pages;}

                $start_item=($display_page_num-1)*$items_per_page;
			    $end_item=$start_item+$items_per_page;

              for ($item_num=$start_item; ($item_num<$end_item && $item_num<$messages_count); $item_num++){

                  if ($message_details=get_item_details('message',$messages[$item_num]['id'])){

                        // items loaded per status above so no need to check again
                      //if ($message_details['status']!=1){continue;}

                      if (isset($message_details['customer_id']) && $message_details['customer_id']==$customer_details['id']){
                        if ($correspondant_details=get_item_details('customer',$message_details['recipient_id'])){
                            $sender_text='Sent to <a href="'.cms_url.'?profile='.$correspondant_details['id'].'">'.$correspondant_details['name'].'</a>';
                        }
                      }
                      elseif (isset($message_details['customer_id']) && $correspondant_details=get_item_details('customer',$message_details['customer_id'])){
                          $sender_text='From <a href="'.cms_url.'?profile='.$correspondant_details['id'].'">'.$correspondant_details['name'].'</a>';
                      }
                      elseif (isset($message_details['name'])){$sender_text='<b>'.$message_details['name'].'</b> (Guest)';}
                      else {$sender_text='Guest';}

                      $timestamp=substr($message_details['id'],0,-3);

                      $sender_text.='<div style="float: right; text-align: right">'.date("d/m/y H:i",$timestamp).'</div>';

                      $tn_size_x=110;
                      $tn_size_y=110;

                      if (!isset($correspondant_details['profile_image']) || !file_exists(sys_data_dir.'/customers/'.$correspondant_details['id'].'/'.$correspondant_details['profile_image'])){
                          $image_fn='no-profile-pic.png';
                          $image_path=cms_theme_dir.'images/users/';
                      }
                      else{
                          $image_fn=$correspondant_details['profile_image'];
                          $image_path=sys_data_dir.'/customers/'.$correspondant_details['id'].'/';
                      }

              	      // check if correct size image exists and create one if it doesn't
              		  $thumbnail_fn=$tn_size_x."x".$tn_size_y.'_p'.$customer_details['id'].'_'.safe_file_name($image_fn);
              		  if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
              	        createthumb($image_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1);
              		  }

                      if (file_exists(sys_image_dir.'/'.$thumbnail_fn)){

                          // get size of thumbnail image
                          $image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);

                          if (isset($correspondant_details)){
                            $link_title='Profile Pic - '.$correspondant_details['name'];
                            $sender_image_content="<a href=\"".cms_url."?profile=".$correspondant_details['id']."\" title=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\"><img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" /></a>";
                          }
                          else {
                            $link_title='No Profile';
                            $sender_image_content="<img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" />";
                          }

                      }

                      $messages_content.='<tr><td valign="top" width="'.$tn_size_x.'">'.$sender_image_content.'</td><td><div style="border-bottom: #b7a586 solid 1px; padding-bottom: 4px; margin-bottom: 4px">'.$sender_text.'</div>';

                      if (isset($message_details['listing_id']) && $listing_details=get_item_details('listing',trim($message_details['listing_id']))){
                          $messages_content.='<div style="margin-bottom: 4px">In response to: <a href="'.item_url('listing',$message_details['listing_id']).'">'.$listing_details['name'].'</a></div>';
                      }
                      if (isset($message_details['rating']) && $message_details['rating']>0){$messages_content.='<div style="margin-bottom: 4px"><img src="'.$display_theme_url.'images/stars'.$message_details['rating'].'small.png" width="105" height="23" alt="Feedback score of '.$total_feedback_score.'" /></div>';}


                      if ($message_details['status']==2){
                        $messages_content.='<div style="border-bottom: #b7a586 solid 1px; padding: 8px 0 8px 0; margin-bottom: 4px">*** SPAM FILTERED ***</div>';
                      }
                      else{
                        $messages_content.='<div style="border-bottom: #b7a586 solid 1px; padding: 8px 0 8px 0; margin-bottom: 4px">'.$message_details['message'].'</div>';
                      }

                      if (isset($message_details['file'])){

                        $messages_content.='<div style="border-bottom: #b7a586 solid 1px; padding: 8px 0 8px 0; margin-bottom: 4px">';
                        $count=0;
                        foreach ($message_details['file'] as $file_name => $value){
                            if ($count>0){$messages_content.=" | ";}
                            $messages_content.="<a href=\"".cms_url."?download=".$file_name."&amp;message_id=".$message_details['id']."\" title=\"".convert($value['size'])."\">".$file_name." (".convert($value['size']).")</a>";
                            $count++;
                        }

                        $messages_content.='</div>';

                      }

                      $messages_content.='<div style="text-align: right">';

                      if (isset($_SESSION['reg_user']) && $_SESSION['reg_user']['id']==$customer_details['id'] && isset($rvi_myaccount) && $message_details['customer_id']!=$customer_details['id']){
                        $messages_content.='<a href="'.cms_url.'?profile='.$message_details['customer_id'].'&amp;message">Reply</a> - ';
                      }

                      if (!isset($rvi_messages) || $rvi_messages!='sent'){
                        $messages_content.='<a href="'.cms_url.'?report&amp;message_id='.$message_details['id'].'">Report</a>';
                      }

                      $messages_content.='</div>';

                      $messages_content.='</td></tr>
                      <tr><td colspan="2"><hr style="height: 1px; color: #b7a586; background-color: #b7a586; border: none;"/></td></tr>';
                  }

              }

                // display page links if more than one page
    			if ($number_of_pages>1){

                    $query_text='';
                    if (isset($rvi_messages) && $rvi_messages=='sent'){$query_text='&amp;messages=sent';}

    				// display previous page link
    				$messages_content.='<tr><td colspan="2"><div style="text-align: center">';
    				if ($display_page_num>1){
    					$prev_page_num=$display_page_num-1;
    					$messages_content.='<a href="'.cms_url.'?myaccount=profile&amp;page='.$prev_page_num.$query_text.'">&lt;&lt; Prev</a>';
    				}
    				// display page numbers
    				if ($display_page_num>10){$start_page_num=$display_page_num-10;}else{$start_page_num=1;}
    				$end_page_num=$display_page_num+10;
    				if ($end_page_num>$number_of_pages){$end_page_num=$number_of_pages;}
    				for ($page_num=$start_page_num; $page_num<=$end_page_num; $page_num++){
    					if ($page_num==$display_page_num){$messages_content.=' '.$page_num.' ';}
    					else{$messages_content.=' <a href="'.cms_url.'?myaccount=profile&amp;page='.$page_num.$query_text.'">'.$page_num.'</a> ';}
    				}
    				// display next page link
    				if ($display_page_num<$number_of_pages){
    					$next_page_num=$display_page_num+1;
    					$messages_content.=' <a href="'.cms_url.'?myaccount=profile&amp;page='.$next_page_num.$query_text.'">Next &gt;&gt;</a>';
    				}
    				$messages_content.='</div></td></tr>';
    			}
            }



        $messages_content.='</table>';

        $page_content['main'].=$messages_content.'</div></div>';









	}else{$page_content['main'].="<div class=\"product_detail\">User profile not found.</div>";}


?>
