<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    $rvi_subject=cms_site_name." - Listing Ref: ".$listing_details['id'];

    $status_options=array("Inactive","Active","Awaiting Payment","Awaiting Approval","Rejected","Expired");

    if (!isset($rvi_mail_body)){$rvi_mail_body="Hi ".short_name($user_details['name']).",\n\n";}

    if ($listing_details['status']==1){
        // active
        $rvi_mail_body.="This is a courtesy email to notify you that your listing ref: ".$listing_details['id']." is now active and can be viewed at the link below.\n\n".item_url('listing',$listing_details['id'],$listing_details['slug'])."\n\nYou can use this link in your emails, correspondence and on other websites and forums to bring visitors directly to your listing. Please keep this email for future reference.";
    }
    elseif ($listing_details['status']==2 && isset($listing_details['order_id'])){
        // Awaiting Payment
        $rvi_mail_body.="This is a courtesy email to notify you on the current status of your listing.\n\nYour listing ref: ".$listing_details['id']." status is ".$status_options[$listing_details['status']]."\n\n".$listing_details['name']."\n".item_url('listing',$listing_details['id'],$listing_details['slug'])."\n\nIf you have not yet made payment and would like to do so now please go to\n".cms_url."?paynow=".$listing_details['order_id'];
    }
    elseif ($listing_details['status']==4){
        // rejected
        $rvi_mail_body.="This is a courtesy email to notify you that your listing ref: ".$listing_details['id']." has been rejected.\n\n".$listing_details['name']."\n".item_url('listing',$listing_details['id'],$listing_details['slug'])."\n\nTo update this listing for review please login to your account at ".cms_site_url."?myaccount";
    }
    elseif ($listing_details['status']==5){
        // expired
        $rvi_mail_body.="This is a courtesy email to notify you that your listing ref: ".$listing_details['id']." has expired.\n\n".$listing_details['name']."\n".item_url('listing',$listing_details['id'],$listing_details['slug'])."\n\nTo renew this listing please login to your account at ".cms_site_url."?myaccount";
    }
    else{
        // default
        $rvi_mail_body.="This is a courtesy email to notify you on the current status of your listing.\n\nYour listing ref: ".$listing_details['id']." status is ".$status_options[$listing_details['status']]."\n\n".$listing_details['name']."\n".item_url('listing',$listing_details['id'],$listing_details['slug']);
    }

    $rvi_mail_body.="\n\n".cms_site_name."\n".cms_site_url;

    // privacy policy note
    $rvi_mail_body.="\n\n------------------------------------\nFor information on how we collect and use your data please read our privacy policy at ".cms_url."?terms#privacy";
    
?>
