<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    $txt['my_account']="My Account";
    $txt['my_account_subscriptions_text']="Listed below are your subscriptions and their expiration dates. To renew a subscription simply click on the renew button link below.";
    $txt['my_account_subscriptions_text_bottom']="Please ensure subscriptions are renewed before their expiry dates.";

    $txt['listing_price']='Price';
    $txt['no_items_found']['products']='No products found.';
    $txt['no_items_found']['listings']='No listings found. Please try a different search or check back later.';
    $txt['account_register']='Register a new account with us below.';
    $txt['listing_message_extra_text']='';
    $txt['no_items_text']='No items found.';
    $txt['no_image']='No Image';

    // user account login/register
    $txt['Register']="Register";
    $txt['Login']="Login";
    $txt['Logout']="Logout";
    $txt['Login_instruction']="If you have a registered account with us, please login below.";
    $txt['Login_fail']="Login failed please enter your email address and password to login.";

    $txt['Name']="Name";
    $txt['Email']="Email";
    $txt['Password']="Password";
    $txt['Remember_Me']="Remember Me";
    $txt['Forgot_Password']="Forgot Password";
    $txt['Forgot_password_instruction']="Forgot your password? Enter your email address below and instructions to reset your password will be emailed to you.";
    $txt['Newsletter_sub_instruction']="Check to receive our latest news and special offers";


    $txt['Thank_You']="Thank You";
    $txt['New_account_registered']="New user account registered.";
    $txt['Registration_submitted_text']="A confirmation email has been sent to you. Please follow the instructions in the email to complete the registration processs. If you do not see this email in your inbox please check your spam/junk mail folders.";
    $txt['Forgot_password_submitted']="Instructions to reset your password have been emailed to you. If you do not receive this email please check your junk mail folders incase it has been incorrectly marked as spam.";

    $txt['Welcome']="Welcome";
    $txt['Guest']="Guest";

    $txt['Warning_enter_name']="Please enter your name.";
    $txt['Warning_enter_email']="Please enter your email address.";
    $txt['Warning_enter_registered_email']="Please enter your registered email address.";
    $txt['Warning_email_registered']="A registered account exists under this email address - <a href=\"".cms_url."?login\">click here to login</a>";
    $txt['Warning_registration_closed']="Sorry, new user registration is currently closed.";
    $txt['Warning_account_not_found']="Account not found.";

    $txt['Search']="Search";
    $txt['Submit']="Submit";

    // shopping cart/checkout
    // $txt['cart_name']='Shopping Cart';
    // $txt['cart_empty']='Your cart is empty. <a href="'.cms_url.'">Click here to continue shopping</a>';
    $txt['cart_name']="Checkout";
    $txt['cart_empty']="Your cart is empty.";
    $txt['Checkout']="Checkout";
    $txt['Checkout_message']="Please enter your billing details and delivery details below.";
    $txt['checkout_returning_customer']="Returning Customer";
    $txt['checkout_new_customer']="New Customer";
    $txt['Shipping']="Shipping";
    $txt['Shipping_message']="Please choose your preferred shipping option below.";

    // buttons
    $txt['btn_submit']="Submit";
    $txt['btn_login']="Login";
    $txt['btn_register']="Register";
    $txt['btn_add_to_cart']="+ Add to Cart";
    $txt['btn_more_info']="More Info";
    $txt['btn_checkout']="Checkout &raquo;";
    $txt['btn_continue']="Continue";
    $txt['btn_continue_shopping']="Continue Shopping";
    $txt['btn_update_cart']="Update Cart";
    $txt['btn_apply_coupon']="Apply Coupon";
    $txt['btn_confirm_order']="Confirm Order &amp; Make Payment";
    $txt['btn_send']="Send";

    // listings
    $txt['Listing']='Listing';
    $txt['Listings']='Listings';
    $txt['my_listings_description']='Here you can modify or remove your listings and also renew expired listings.';
    $txt['listing_renew']='Renew';
    $txt['listing_renewal']='Renewal';

    $txt['listing_contact_form_heading']='Enquiry Form';
    $txt['listing_contact_form_text']='Enter your contact details carefully so the person can reply back to you. Make sure your email address is correct, you\'ll need it to login and view your messages.';

    // subscriptions
    $txt['Subscription']="Subscription";
    $txt['Subscriptions']="Subscriptions";
    $txt['my_subscriptions_description']="To renew your subscriptions simply check the boxes and click the Renew button. If you have just purchased or renewed a subscription please allow 24hrs after payment for it to be processed and updated.";
    // $txt['subscription_expiry_email_subject']="Subscription Expiration Notifcation";
    $txt['subscription_expiry_email_subject']="Expiring Subscriptions";
    $txt['subscription_expiry_text']="Your subscriptions below have expired or are at risk of expiring:";
    // $txt['subscription_renewal_email_subject']="Subscription Renewal Notice";
    $txt['subscription_renewal_email_subject']="Important Renewal Reminder";
    //$txt['subscription_renewal_reminder']="For your review, listed below are your subscriptions and their expiration dates:";
    $txt['subscription_renewal_reminder']="Your subscriptions below are due for renewal:";
    $txt['subscription_renewal_instructions']="To review and renew your subscriptions simply login to your account using the link below.";
    $txt['subscription_renewal_note']="Please ensure your subscriptions are renewed before their expiry dates.";

    // orders
    $txt['Orders']="Orders";
    $txt['my_orders_description']="Please allow 24hrs after payment for orders to be processed and updated.";
    $txt['order_id']="Order #";
    $txt['unpaid']="Unpaid";
    $txt['pay_now']="Pay Now";
    $txt['pending']="Pending";
    $txt['excl_tax']="Excl. Tax";
    //$txt['excl_tax']="Excl. VAT";
    $txt['invoice_items_heading']="Items";
    $txt['invoice_Deposit']="Deposit";
    $txt['invoice_Deposit_followtxt']="required for work commencement.";

?>
